/*====================================================================
 
 Objectweb Browser Framework
 Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
 Contact: openccm@objectweb.org
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA
 
 Initial developer(s): Jerome Moroy.
 Contributor(s): ______________________________________.
 
 ---------------------------------------------------------------------
 $Id: CreateTemplateAction.java,v 1.3 2004/04/14 09:43:14 rouvoy Exp $
 ====================================================================*/

package org.objectweb.util.browser.plugins.fractal.menu;

import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.TreeView;
import org.objectweb.util.browser.core.api.ContextContainer;
import org.objectweb.util.browser.core.common.DynamicTree;
import org.objectweb.util.browser.gui.api.DialogAction;
import org.objectweb.util.browser.gui.api.DialogBox;
import org.objectweb.util.browser.gui.lib.LabelBox;
import org.objectweb.util.browser.gui.lib.TreeChooserBox;

/**
 * This action allows to create a new template.
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class CreateTemplateAction 
  implements MenuItem, DialogAction 
{
    
    //==================================================================
    //
    // Internal states.
    //
    //==================================================================
    
    /** The selected type. */
    protected TreeChooserBox type_;
    
    /** The controller desc (String with Julia). */
    protected LabelBox name_, templateControllerDesc_, controllerDesc_, contentDesc_;
    
    /** The ContextContainer where adding the type. */
    protected ContextContainer cc_;
    
    //==================================================================
    //
    // No constructor.
    //
    //==================================================================
    
    //==================================================================
    //
    // Internal methods.
    //
    //==================================================================
    
    /**
     * Create a box containing all the box to specify all the params.
     */
    protected void createBox(DialogBox dialogBox, DynamicTree tree) {
        name_ = new LabelBox("Name");
        dialogBox.addElementBox(name_);
        type_ = new TreeChooserBox("Type", tree);
        dialogBox.addElementBox(type_);
        templateControllerDesc_ = new LabelBox("Template Controller Desc");
        dialogBox.addElementBox(templateControllerDesc_);
        controllerDesc_ = new LabelBox("Controller Desc");
        dialogBox.addElementBox(controllerDesc_);
        contentDesc_ = new LabelBox("Content Desc");
        dialogBox.addElementBox(contentDesc_);
    }
    
    //==================================================================
    //
    // Public methods for ExtendedActionListener interface.
    //
    //==================================================================    
    
    public void actionPerformed(MenuItemTreeView e) throws Exception{     
        
        cc_ = (ContextContainer)e.getSelectedObject();
        /*    
         Julia julia = new Julia();
         Component bootstrap = julia.instantiateFc();
         //TemplateFactory templateFactory = Fractal.getTemplateFactory(Fractal.getBootstrapComponent());
          //TemplateFactory templateFactory = Fractal.getTemplateFactory(julia.instantiateFc());
           templateFactory_ = (TemplateFactory)bootstrap.getFcInterface(TemplateFactory.TEMPLATE_FACTORY);
           
           TreeProvider treeProvider = new DefaultTreeProvider();
           DynamicTree tree = treeProvider.createDynamicTree(e);
           
           DialogBox dialog = new DefaultDialogBox("Create a new Template");      
           createBox(dialog, tree);
           dialog.setValidateAction(this);
           dialog.show();*/
    }
    
    /**
     * @see org.objectweb.util.browser.api.MenuItem#isActive(org.objectweb.util.browser.gui.common.TreeView)
     */
    public int getStatus(TreeView treeView) {
        return MenuItem.ENABLED_STATUS;
    }
    
    //==================================================================
    //
    // Public methods for DialogAction interface.
    //
    //==================================================================
    
    /**
     * Executes an action
     */
    public void executeAction() throws Exception {
        /*        Type type = null;
         if(type_.getObject()!=null && Type.class.isAssignableFrom(type_.getObject().getClass())) {
         type = (Type)type_.getObject();
         } else {
         throw new Exception("You must select an org.objectweb.fractal.api.Type object !");   
         }
         String name = name_.getLabel();
         String templateControllerDesc = templateControllerDesc_.getLabel();
         String controllerDesc = controllerDesc_.getLabel();
         String contentDesc = contentDesc_.getLabel();
         cc_.addEntry(name+"Tmpl",templateFactory_.createFcTemplate(type,templateControllerDesc,controllerDesc,contentDesc));
         */
    }    
}