/*====================================================================
 
 Objectweb Browser Framework
 Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
 Contact: openccm@objectweb.org
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA
 
 Initial developer(s): Jerome Moroy.
 Contributor(s): ______________________________________.
 
 ---------------------------------------------------------------------
 $Id: ComponentPanel.java,v 1.2 2004/04/14 09:43:15 rouvoy Exp $
 ====================================================================*/

package org.objectweb.util.browser.plugins.fractal.panel;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.NameController;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.util.browser.api.TreeView;
import org.objectweb.util.browser.core.panel.TitlePanel;

/**
 * Title for component panel.
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * @version 0.1
 */
public class ComponentPanel
     extends TitlePanel 
{
    public String getTitle(TreeView treeView) {
        Component comp = (Component) treeView.getSelectedObject();
        NameController nameController = null;
        try {
            nameController = Fractal.getNameController(comp);
        } catch(NoSuchInterfaceException e) { }
        if (nameController!=null)
            return nameController.getFcName() + " interfaces";
        return "Component interfaces";
    }
}
