/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.api;

/**
 * Allows to specify the contents of a <code>javax.swing.JTable</code>.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public interface Table 
         extends View
{

    /**
     * Returns the table headers.
     * @param treeView A view on the tree.
     * @return The titles of the columns 
     */
    public String[] getHeaders(TreeView treeView);

    /**
     * Returns the rows of the table. 
     * If a cell is an <code>Entry</code> object, the <code>Entry.getName()</code> is displayed. 
     * @param treeView A view on the tree.
     * @return The rows to display.
     */
    public Object[][] getRows(TreeView treeView);

}