/*====================================================================

Objectweb Browser framework
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.core.icon;

import java.awt.Component;
import java.awt.Graphics;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public class NumberIcon 
    extends javax.swing.plaf.metal.MetalIconFactory.FileIcon16{

    //==================================================================
    //
    // Internal states.
    //
    //==================================================================

    /** The number to display */
    protected int number_;

    //==================================================================
    //
    // Constructors.
    // 
    //==================================================================

    /**
     * Default constructor.
     * @param number The number to display
     */
    public NumberIcon(int number){
        number_ = number;    
    }

    //==================================================================
    //
    // Internal methods.
    //
    //==================================================================

    /**
     * Draws the point in the default object icon
     */
    private void myPaint(Component c, Graphics g) {
        java.awt.Font oldFont = g.getFont();
        g.setFont(oldFont.deriveFont(java.awt.Font.BOLD));
        g.drawString((new Integer(number_)).toString(),2,12);
        g.setFont(oldFont);
        //g.drawRect(0,0,19,15);
    }

    //==================================================================
    //
    // Public methods.
    //
    //==================================================================

    public void paintIcon(Component c, Graphics g, int x, int y) {
        myPaint(c,g);   
    }

}