/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.core.panel;

import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.objectweb.util.browser.api.Panel;
import org.objectweb.util.browser.core.api.CompositePanelFactory;
//import org.objectweb.util.browser.core.api.PanelFactory;
import org.objectweb.util.browser.core.api.ViewFactory;

/**
 * 
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class DefaultCompositePanelFactory 
    extends DefaultPanelFactory 
 implements CompositePanelFactory {

    //==================================================================
    //
    // Internal state.
    //
    //==================================================================

    protected List viewFactoryList_;

    //==================================================================
    //
    // Constructor.
    // 
    //==================================================================

    public DefaultCompositePanelFactory(){
        viewFactoryList_ = new Vector();
    }

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    protected Panel createPanel(Object object){
        DefaultCompositePanel compositePanel = new DefaultCompositePanel();
        Iterator iterator = viewFactoryList_.iterator(); 
        while (iterator.hasNext()) {
            ViewFactory element = (ViewFactory) iterator.next();
            Panel panel = element.newPanel(object);
            if(panel!=null)
                compositePanel.add(panel);
        }
        return compositePanel;        
    }

    //==================================================================
    //
    // Surchaging method from DefaultPanelFactory class.
    //
    //==================================================================

    /**
     * Return a Panel associated to the param's object.
     *
     * @return The associated panel or null.
     */
    /*public Panel newPanel(Object object) {
        if (subPanels_.size()>0){
            DefaultCompositePanel compositePanel = new DefaultCompositePanel();
            compositePanel.add(createPanel(object));
            Iterator it = subPanels_.iterator();
            while(it.hasNext()){
                compositePanel.add(((PanelFactory)it.next()).newPanel(object));
            }
            return compositePanel;            
        } else {
            return createPanel(object);
        }
    }*/

    //==================================================================
    //
    // Public methods for CompositePanelFactory interface.
    //
    //==================================================================
    
    /**
     * Overriding methods
     * @see org.objectweb.util.browser.core.api.CompositePanelFactory#add(org.objectweb.util.browser.core.api.PanelFactory)
     */
    public void add(ViewFactory viewFactory) {
        if(viewFactory!=null)
            viewFactoryList_.add(viewFactory);        
    }

}


