/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): offroy ________________________.
Contributor(s): ______________________________________.

====================================================================*/

package org.omg.lifl.eclipse.plugin.project.OpenCCM.utils;

import java.util.HashMap;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.SubProgressMonitor;
import org.eclipse.jdt.core.JavaCore;
import org.omg.lifl.eclipse.plugin.project.OpenCCM.ProjectCreationWizardPage;

/**
 * This class ...
 *
 * @author offroy@lifl.fr
 *
 * @version 0.1
 */
public class CPManager {

    /**
     * @param page
     * @param monitor
     */
    public static void setEclipseCP(
        ProjectCreationWizardPage page,
        IProgressMonitor monitor) {
        try {
            // TODO make ORBacus independent
            String varSeparator = "__";
            HashMap ORBJarConfig = ORBconfigJar();

            String ORBName =
                createVarName(page.getOpenccmConfigChooser().get_ORBName());

            String jarName[] = (String[]) ORBJarConfig.get(ORBName);
            for (int i = 0; i < jarName.length; i++) {
                JavaCore
                    .setClasspathVariable(ORBName + varSeparator + jarName[i],
                // the name of the new Variable
                new Path(
                    page
                        .getOpenccmConfigChooser()
                        .get_ORBpreference()
                        .get_Name()
                        + "/lib/" 
                        + jarName[i]
                        + ".jar"),  
                    new SubProgressMonitor(monitor, 1));

            }
            
            // show all variable defined in the workbench
            /*String varNames[] = JavaCore.getClasspathVariableNames();
            for (int i = 0; i < varNames.length; i++) {
                System.out.println(
                    "var : "
                        + varNames[i]
                        + " = "
                        + JavaCore
                            .getClasspathVariable(varNames[i])
                            .toOSString());
            }*/

        } catch (CoreException e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }
    }
    
    /**
     * @return
     */
    private static HashMap ORBconfigJar() {
        HashMap result = new HashMap();
        String ORBs[] =
            { createVarName("ORBacus-4.1"), createVarName("OpenORB-1.3.0")};
        String jarNameORB[][] = { { "OB", "OBNaming" }, {
                "openorb-1.3.0", "openorb_tools-1.3.0"}
        };

        for (int i = 0; i < ORBs.length; i++) {
            result.put(ORBs[i], jarNameORB[i]);
        }

        return result;
    }

    /**
     * @param string
     * @return
     */
    private static String createVarName(String string) {
        char separator = '_';
        char separators[] = { '-', '.' };

        String result = string;
        for (int i = 0; i < separators.length; i++) {
            result = result.replace(separators[i], separator);
        }
        return result;
    }
}