/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmfClientComponents.ManagedObjectClientComposition;

import ist.coach.coachEmfClientComponents.gui.GuiMaster;
import java.text.DateFormat;
import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfServices.EmfBasicLog.LogSeverity;
import ist.coach.coachEmfClientComponents.gui.GuiMessages;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmfClientComponents/ManagedObjectClientComposition/ManagedObjectClientHome_impl/ManagedObjectClient_impl/logNewRecordSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class logNewRecordSegImpl
     extends ist.coach.coachEmfClientComponents.ManagedObjectClientComposition.logNewRecordSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public logNewRecordSegImpl()
    {

    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_LogNewRecordConsumer::push operation.
     */
    public void
    push(ist.coach.coachEmfServicesComponents.LogNewRecord event)
    {

	    //System.err.println("---->LogNewRecord received: ");
		//System.err.println("Source Object Name = " + Utils.name2string(event.source));
		//System.err.println("Source Object Type = " + event.sourceClass);
		//System.err.println("logRecordId = " + String.valueOf(
		//			event.logRecordId));
		//System.err.println("Time = " + String.valueOf(event.eventTime.time));

		java.util.Date event_date = new java.util.Date(event.eventTime.time);
		String event_type_str = GuiMessages.info_log;
		String event_type = GuiMaster.INFO_LOG;

		switch(event.severity.value()) {
		  case LogSeverity._Error :
					event_type_str = GuiMessages.error_log;
					event_type = GuiMaster.ERROR_LOG;
					break;
		  case LogSeverity._FatalError :
					event_type_str = GuiMessages.fatal_error_log;
					event_type = GuiMaster.FATAL_LOG;
					break;
		  case LogSeverity._Warning :
				event_type_str = GuiMessages.warning_log;
				event_type = GuiMaster.WARNING_LOG;
				break;
		};
	  ManagedObjectClientImpl main_segment = (ManagedObjectClientImpl) get_main_segment();
		    // if user has unsubscribed from log events of this type
		if (! main_segment.subscribed_log_events.contains(event_type))
		  return;

		DateFormat df = DateFormat.getDateTimeInstance(DateFormat.DEFAULT, DateFormat.DEFAULT);
		String time_str = df.format(event_date);


		main_segment.ui_client.print(time_str,
				event_type_str,
				Utils.name2string(event.source),
				event.sourceClass,
				String.valueOf(event.logRecordId),
				event.info
				);
    }

}
