package ist.coach.coachEmfClientComponents.gui;

import javax.swing.ImageIcon;

import intt.itu.itut_x780.ManagedObjectValueType;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.notDeletable;
import intt.itu.itut_x780.deleteOnlyIfNoContainedObjects;
import intt.itu.itut_x780.deleteContainedObjects;

public class MOTreeObject {
	String key;
	ImageIcon leafIcon, nodeIcon;
	String toolTipText;

	static String[] subordinate_names = { "ManagedObject", 
											"ManagedElement", 
											"IpNode"};
//	static String[] subordinate_vtype = { "MOTreeObject", 
//											"VisualManagedElement",
//											"VisualIpNode"};
	static boolean canRefresh = false;

		// HACK
		// This must be the type declared in idl as objectClass!!!!!
	static String object_type = "ManagedObject";

	static String DISPLAY_TYPE = "ManagedObject";
	//
	// create arguments
	//
	static String[] create_arg_name = {"Name"};
	static String[] create_arg_editor = { "", ""};
	static String[] create_arg_renderer = { "", ""};
	//
	// get/set arguments
	//
	static String[] attributes_name = {"Name", 
										"Element Type",
                                        "Creation Source",
                                        "Delete Policy"};

	static boolean[] attributes_readonly = {false, false, false, false};
	private String label = null;
	
 
	//static JPopupMenu popup = null;

public MOTreeObject(String key) {

	this.key = key;
	leafIcon = new ImageIcon(MOTreeObject.class.getResource("images/managedobject_icon.gif"));
	nodeIcon = new ImageIcon(MOTreeObject.class.getResource("images/managedobject_icon.gif"));
	toolTipText = new String(DISPLAY_TYPE);

		//
		// setup the label
		//
	int objIndex = 0;
    int lastIndex = key.lastIndexOf("/");

	if (lastIndex > 0) {
		String object_id = key.substring(0, lastIndex);
		if (object_id != null && object_id.length() > 0 &&
				(objIndex = object_id.lastIndexOf("/")) > 0) {

				label = object_id.substring(objIndex+1);
		}
		else
				label = key;
		lastIndex =label.lastIndexOf(".");
		if (lastIndex > 0)	
				label = label.substring(0, lastIndex);
	}
	else {
		lastIndex = key.lastIndexOf(".");
		if (lastIndex > 0)
			label = key.substring(0, lastIndex);
		else
			label = key;
	}

}


/*
 This operation is used to provide the label of the tree node
*/
	public String toString() {
		return label;
	}

	public String key() {
		return key;
	}

	public Object[] translate_values(ManagedObjectValueType value_type) {

		Object[] values = new Object[attributes_name.length];
		for(int i = 0; i < values.length; i++)
			values[i] = "unspecified";

		if (value_type == null) 
			return values;

		String name_str = new String();
		if (value_type.name != null && value_type.name.length > 0) {
        	for (int i = 0; i < value_type.name.length; i++) {
            	name_str = name_str.concat(value_type.name[i].id 
							+ "." + value_type.name[i].kind);

            	if (i < value_type.name.length -1 ) {
                	name_str = name_str.concat("/");
            	}
        	}
		}
		else
				GuiClient.println("name value retrieved is null");

		values[0] = new String(name_str);
		values[1] = new String(value_type.objectClass);
		switch(value_type.creationSource.value()) {
			case SourceIndicatorType._resourceOperation :
				values[2] = new String("System Created");
				break;
			case SourceIndicatorType._managementOperation :
				values[2] = new String("Manager Created");
				break;
			default:
				values[2] = new String("Unknown");
		}
		switch(value_type.deletePolicy) {
			case intt.itu.itut_x780.notDeletable.value:
				values[3] = new String("Not Deletable");
				break;
			case intt.itu.itut_x780.deleteOnlyIfNoContainedObjects.value:
				values[3] = new String("Delete only if zero contained objects");
				break;
			case intt.itu.itut_x780.deleteContainedObjects.value:
				values[3] = new String("Remove will also remove subordinate objects");
				break;
		}
	
		return values;
	}

	java.util.Vector translate_updates(java.util.Hashtable values) {

			System.err.println("Translate has been called on MOTreeObject!");
			return new java.util.Vector();
	}
}
