/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmfServicesComponents.SnmpAdapterProviderComposition;

//import ist.coach.coachEmfServicesComponents.SnmpObjectData;
import org.opennms.protocols.snmp.*;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServicesComponents.SnmpAdapterProviderPackage.trap_targetConnection;
//import ist.coach.coachEmfServicesComponents.SnmpProtocolConverter;

import org.omg.CORBA.Any;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmfServicesComponents/SnmpAdapterProviderComposition/SnmpAdapterProviderHome_impl/SnmpAdapterProvider_impl/connectorSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class connectorSegImpl
     extends ist.coach.coachEmfServicesComponents.SnmpAdapterProviderComposition.connectorSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
	/**
     ** Private ORB reference (used to create Anys)
     **/
    private org.omg.CORBA.ORB orb;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public connectorSegImpl()
    {
	  		orb = org.objectweb.ccm.CORBA.TheORB.getORB();
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::SnmpConnector::getSnmpTable operation.
     */
    public ist.coach.coachEmfServices.SnmpAdapter.DataType[]
    getSnmpTable(String tableStart, String host, int port, String community)
    throws ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
        //
        //  DONE : implement
        //


	SnmpProtocolConverter snmpConverter = new SnmpProtocolConverter(host, community, port, tableStart);

	snmpConverter.snmpWalk();

	if (snmpConverter.agentResponded() == false) {

		System.err.println("Agent did not respond!");
		throw new SnmpApplicationError(ExceptionMessages.agent_response_error);
	}


	DataTypeImpl [] snmpTable = new DataTypeImpl[snmpConverter.resultSet.size()];

	for (int i = 0; i < snmpConverter.resultSet.size(); i++) {

		SnmpVarBind vb = (SnmpVarBind)snmpConverter.resultSet.get(i);
		Any value = orb.create_any();
		value = SnmpAdapterProviderImpl.convertSnmpSyntaxToAny(vb.getValue());
		if (value == null) {
			System.err.println("SnmpAdapter>Could not encapsulate SNMP attribute value into a CORBA Any");
			throw new SnmpApplicationError(ExceptionMessages.agent_create_error);
		}
		else  {
			snmpTable[i] = new DataTypeImpl(vb.getName().toString(), value, vb.getValue().typeId());

		}
	}

		return snmpTable;
    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::SnmpConnector::getNext operation.
     */
    public ist.coach.coachEmfServices.SnmpAdapter.DataType
    getNext(String identifier, String host, int port, String community)
    throws ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
       //
        //  DONE : implement
        //

	SnmpProtocolConverter snmpConverter = new SnmpProtocolConverter(host, community, port, null);

	snmpConverter.snmpGetNext(new SnmpObjectId(identifier));

	if (snmpConverter.agentResponded() == false) {

		System.err.println("Agent did not respond!");
		throw new SnmpApplicationError(ExceptionMessages.agent_response_error);
	}

	if (snmpConverter.resultSet.size() == 0) {

		System.err.println("Could not retrieve attribute with oid " + identifier);
		throw new SnmpApplicationError(ExceptionMessages.agent_get_error);
	}

	Any value = this.orb.create_any();
	SnmpVarBind vb = (SnmpVarBind)snmpConverter.resultSet.elementAt(0);
	String oid = vb.getName().toString();
	value = SnmpAdapterProviderImpl.convertSnmpSyntaxToAny(vb.getValue());

	if (value == null) {
		System.err.println("Could not retrieve attribute with oid " + identifier);
		throw new SnmpApplicationError(ExceptionMessages.agent_get_error);
	}

	DataTypeImpl result = new DataTypeImpl(oid, value, vb.getValue().typeId());

	return result;

    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::Connector::get operation.
     */
    public ist.coach.coachEmfServices.SnmpAdapter.DataType
    get(String identifier, String host, int port, String community)
    throws ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
        //
        //  DONE : implement
        //
	//System.err.println("SnmpAdapter>get " + identifier + " on " + host + ":" + port +
	//	  " community = " + community);
	SnmpProtocolConverter snmpConverter = new SnmpProtocolConverter(host, community, port, null);

	SnmpVarBind [] vblist = new SnmpVarBind[1];
	vblist[0] = new SnmpVarBind(new SnmpObjectId(identifier));

	snmpConverter.snmpGet(vblist);

	if (snmpConverter.agentResponded() == false) {

		System.err.println("Agent did not respond!");
		throw new SnmpApplicationError(ExceptionMessages.agent_response_error);
	}

	if (snmpConverter.resultSet.size() == 0) {

		System.err.println("Could not retrieve attribute with oid " + identifier);
		throw new SnmpApplicationError(ExceptionMessages.agent_get_error);
	}

	//System.err.println("Got " + ((SnmpVarBind)snmpConverter.resultSet.elementAt(0)).toString());

	Any value = this.orb.create_any();
	SnmpVarBind vb = (SnmpVarBind)snmpConverter.resultSet.elementAt(0);
	String oid = vb.getName().toString();
	value = SnmpAdapterProviderImpl.convertSnmpSyntaxToAny(vb.getValue());

	if (value == null) {
		System.err.println("Could not retrieve attribute with oid " + identifier);
		throw new SnmpApplicationError(ExceptionMessages.agent_get_error);
	}

	DataTypeImpl result = new DataTypeImpl(oid, value, vb.getValue().typeId());

	return result;
    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::Connector::getBulk operation.
     */
    public ist.coach.coachEmfServices.SnmpAdapter.DataType[]
    getBulk(String[] identifiers, String host, int port, String community)
    throws ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
        //
        //  DONE : implement
        //
	SnmpProtocolConverter snmpConverter = new SnmpProtocolConverter(host, community, port, null);

	int numRequested = identifiers.length;

	SnmpVarBind [] vblist = new SnmpVarBind[numRequested];

	for (int i = 0; i < numRequested; i++)
		vblist[i] = new SnmpVarBind(new SnmpObjectId(identifiers[i]));

	snmpConverter.snmpGet(vblist);

	if (snmpConverter.agentResponded() == false) {

		System.err.println("Agent did not respond!");
		throw new SnmpApplicationError(ExceptionMessages.agent_response_error);
	}

	if (snmpConverter.resultSet.size() == 0) {
		System.err.println("Could not retrieve attributes with requested identifiers");
		throw new SnmpApplicationError(ExceptionMessages.agent_get_error);
	}

	DataTypeImpl [] result = new DataTypeImpl[snmpConverter.resultSet.size()];


	for (int i = 0; i < snmpConverter.resultSet.size(); i++) {

		Any value = this.orb.create_any();
		SnmpVarBind vb = (SnmpVarBind)snmpConverter.resultSet.elementAt(i);
		String oid = vb.getName().toString();
		value = SnmpAdapterProviderImpl.convertSnmpSyntaxToAny(vb.getValue());

		if (value == null) {
			System.err.println("Could not encapsulate SNMP attribute value into a CORBA Any");
			throw new SnmpApplicationError(ExceptionMessages.agent_create_error);
		}
		else
			result[i] = new DataTypeImpl(((SnmpVarBind)snmpConverter.resultSet.elementAt(i)).getName().toString(), value, vb.getValue().typeId());
	}

	//System.err.println("getBulk is ready to return!!");
	return result;

    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::Connector::set operation.
     */
    public void
    set(ist.coach.coachEmfServices.SnmpAdapter.DataType data, String host, int port, String community)
    throws ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
        //
        //  DONE : implement
        //
		SnmpProtocolConverter snmpConverter = new SnmpProtocolConverter(host, community, port, null);

		SnmpVarBind [] vblist = new SnmpVarBind[1];
		SnmpSyntax value = SnmpAdapterProviderImpl.convertAnyToSnmpSyntax(data.value, data.code);
		if (value == null) {
			System.err.println("Could not convert DataType to an SnmpSyntax");
			throw new SnmpApplicationError(ExceptionMessages.agent_create_error);
		}

		vblist[0] = new SnmpVarBind(new SnmpObjectId(data.identifier), value);

		snmpConverter.snmpSet(vblist);

		if (snmpConverter.agentResponded() == false) {

			System.err.println("Agent did not respond!");
			throw new SnmpApplicationError(ExceptionMessages.agent_response_error);
		}

		if (snmpConverter.resultSet.size() == 0) {

			System.err.println("Could not set attribute with oid " + data.identifier);
			throw new SnmpApplicationError(ExceptionMessages.agent_set_error);
		}
    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::Connector::setBulk operation.
     */
    public void
    setBulk(ist.coach.coachEmfServices.SnmpAdapter.DataType[] data, String host, int port, String community)
    throws ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
        //
        //  DONE : implement
        //
		SnmpProtocolConverter snmpConverter = new SnmpProtocolConverter(host, community, port, null);
		int numRequested = data.length;
		//System.err.println("SnmpAdapter:setBulk> Data size = " + numRequested);
		SnmpVarBind [] vblist = new SnmpVarBind[numRequested];

		for (int i = 0; i < numRequested; i++) {
		    //System.err.println("[" + i + "] = ");

			SnmpSyntax value = SnmpAdapterProviderImpl.convertAnyToSnmpSyntax(data[i].value, data[i].code);
			vblist[i] = new SnmpVarBind(new SnmpObjectId(data[i].identifier), value);
			//System.err.println("identifier = " +
			//	  data[i].identifier + " value = " + value);
		}

		snmpConverter.snmpSet(vblist);

		if (snmpConverter.agentResponded() == false) {

			System.err.println("Agent did not respond!");
			throw new SnmpApplicationError(ExceptionMessages.agent_response_error);
		}

		if (snmpConverter.resultSet.size() == 0) {
			System.err.println("setBulk>Could not set attributes");

			throw new SnmpApplicationError(ExceptionMessages.agent_get_error);
		}
    }

}
