/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.itut_m3120Components.ManagedElementProviderComposition;

import intt.itu.itut_x780.UIDType;

import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.ManagedObjectValueType;
import intt.itu.itut_x780.AttributeValueChangeType;
import intt.itu.itut_x780.AttributeValueType;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.OperationalStateTypeHelper;

import intt.itu.itut_m3120.NOuserLabelPackageException;
import intt.itu.itut_m3120.NOvendorNamePackageException;
import intt.itu.itut_m3120.NOversionPackageException;
import intt.itu.itut_m3120.NOlocationNamePackageException;
import intt.itu.itut_m3120.ManagedElementValueType;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.StateChangedEventImpl;
import ist.coach.coachEmfCommon.ObjectDeletionImpl;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import java.util.Hashtable;
import ist.coach.coachEmfServices.EmfBasicLog.*;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/itut_m3120Components/ManagedElementProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class ManagedElementProviderImpl
     extends ist.coach.itut_m3120Components.ManagedElementProviderComposition.ManagedElementProvider_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
    private String _facade_name;
    private static int notifId = 200;
	protected static Hashtable elements;
	private BasicLog logSupport;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public ManagedElementProviderImpl()
    {
	 elements = new java.util.Hashtable();
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //
		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		System.err.println(facade_name() + " configuration completed...");
    }
	// ==================================================================
    //
    // Util Methods.
    //
    // ==================================================================
   protected static synchronized int getUniqueNotificationIdentifier() {

       notifId++;

       return (notifId);
   }
    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     */
    public String
    facade_name()
    {
        //
        //  DONE : implement
        //
        return _facade_name;
    }

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     */
    public void
    facade_name(String facade_name)
    {
        //
        //  DONE : implement
        //
		if (facade_name != null)
			_facade_name = new String(facade_name);
    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::administrativeStateGet operation.
     */
    public intt.itu.itut_x780.AdministrativeStateType
    administrativeStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE: implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.administrativeState;
    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::administrativeStateSet operation.
     */
    public void
    administrativeStateSet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.AdministrativeStateType administrativeState)
    throws intt.itu.itut_x780.ApplicationError
    {
	    //
		//  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }
		synchronized(elements) {
	      ManagedElementValueType mo_value =
		  (ManagedElementValueType) elements.remove(key);
			mo_value.administrativeState = administrativeState;

		  elements.put(key, mo_value);
		}
		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "AdministrativeState set to " + administrativeState);
    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::operationalStateGet operation.
     */
    public intt.itu.itut_x780.OperationalStateType
    operationalStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.operationalState;

    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::usageStateGet operation.
     */
    public intt.itu.itut_x780.UsageStateType
    usageStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.usageState;

    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::userLabelGet operation.
     */
    public String
    userLabelGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_m3120.NOuserLabelPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.userLabel;
    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::userLabelSet operation.
     */
    public void
    userLabelSet(org.omg.CosNaming.NameComponent[] name, String userLabel)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_m3120.NOuserLabelPackageException
    {
 	    //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }
		synchronized(elements) {
			ManagedElementValueType mo_value =
			(ManagedElementValueType) elements.remove(key);
			mo_value.userLabel = userLabel;

		    elements.put(key, mo_value);
		}
		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "User Label set to " + userLabel);
	}

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::vendorNameGet operation.
     */
    public String
    vendorNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_m3120.NOvendorNamePackageException
    {
         //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.vendorName;
    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::vendorNameSet operation.
     */
    public void
    vendorNameSet(org.omg.CosNaming.NameComponent[] name, String vendorName)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_m3120.NOvendorNamePackageException
    {
 	    //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }

		synchronized(elements) {
	      ManagedElementValueType mo_value =
			  (ManagedElementValueType) elements.remove(key);
		  mo_value.vendorName = vendorName;

		  elements.put(key, mo_value);
		}
		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "Vendor Name set to " + vendorName);
    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::versionGet operation.
     */
    public String
    versionGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_m3120.NOversionPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.version;
    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::versionSet operation.
     */
    public void
    versionSet(org.omg.CosNaming.NameComponent[] name, String version)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_m3120.NOversionPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }
		synchronized(elements) {
	      ManagedElementValueType mo_value =
			(ManagedElementValueType) elements.remove(key);
	      mo_value.version = version;

		  elements.put(key, mo_value);
		}
		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "Version set to " + version);
    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::locationNameGet operation.
     */
    public String
    locationNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_m3120.NOlocationNamePackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.locationName;

    }

    /**
     * Implementation of the ::itut_m3120::ManagedElement_F::locationNameSet operation.
     */
    public void
    locationNameSet(org.omg.CosNaming.NameComponent[] name, String locationName)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_m3120.NOlocationNamePackageException
    {
	    //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }
		synchronized(elements) {
	      ManagedElementValueType mo_value =
			(ManagedElementValueType) elements.remove(key);
	      mo_value.locationName = locationName;

		  elements.put(key, mo_value);
		}
		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "Location Name set to " + locationName);
	}

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     */
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
        //
        //  DONE : implement
        //
        return Utils.string2name(_facade_name);
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     */
    public String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        //  DONE : implement
        //
       		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.objectClass;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     */
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
       		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedElementValueType mo_value =
			(ManagedElementValueType) elements.get(Utils.name2string(name));
		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "attributesGet finished successfully");
		return mo_value;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     */
    public String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.packages;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     */
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
        		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.creationSource;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     */
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.deletePolicy;

    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     */
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);

		}
		ManagedElementValueType mo_value =null;
		synchronized(elements) {
					mo_value = (ManagedElementValueType) elements.remove(Utils.name2string(name));
		}
		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);
		get_context().push_objectDeletion_alarm(new ObjectDeletionImpl(eventTime, name,
										mo_value.objectClass,
										getUniqueNotificationIdentifier(),
										mo_value.creationSource,
										new AttributeValueType[0]));
    }

}
