/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.itut_q816Components.ChannelFinderProviderComposition;

import ist.coach.coachEmfCommon.ChannelChangeEventImpl;

import java.util.Hashtable;
import intt.itu.itut_q816.ChannelInfoType;
import intt.itu.itut_q816.ChannelModificationType;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/itut_q816Components/ChannelFinderProviderComposition/ChannelFinderProviderHome_impl/ChannelFinderProvider_impl/adminSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class adminSegImpl
     extends ist.coach.itut_q816Components.ChannelFinderProviderComposition.adminSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public adminSegImpl()
    {
    }


    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_q816::ChannelFinderComponent::register operation.
     */
    public void
    register(String channelID, String channelClass, String[] eventTypes, String[] excludedEventTypes, String[] sourceClasses, String[] excludedSourceClasses, org.omg.CORBA.Object channel)
    throws intt.itu.itut_q816.ChannelAlreadyRegistered,

           intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		System.err.println("ChannelFinder> register is called for " +
				channelID + " of type " + channelClass);

		if (ChannelFinderProviderImpl.channels.containsKey(channelID)) {
			System.err.println("ChannelFinder> register found channel already registered..");
			throw new intt.itu.itut_q816.ChannelAlreadyRegistered();
		}

		intt.itu.itut_q816.ChannelInfoType channelInfo = new ChannelInfoType(channelID,
																channelClass,
																eventTypes,
																excludedEventTypes,
																sourceClasses,
																excludedSourceClasses,
																channel);

		synchronized(ChannelFinderProviderImpl.channels) {
		  ChannelFinderProviderImpl.channels.put(channelID, channelInfo);
		}

		get_context().push_channelChange_alarm(new ChannelChangeEventImpl(
							ChannelModificationType.ChannelCreate,
							channelInfo)); 
    }

    /**
     * Implementation of the ::itut_q816::ChannelFinderComponent::update operation.
     */	
    public void
    update(String channelID, String channelClass, String[] eventTypes, String[] excludedEventTypes, 
		String[] sourceClasses, String[] excludedSourceClasses, org.omg.CORBA.Object channel)
    throws intt.itu.itut_q816.ChannelNotFound,
		intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		System.err.println("ChannelFinder> update is called for " +
				channelID + " of type " + channelClass);

		if (! ChannelFinderProviderImpl.channels.containsKey(channelID)) {
			System.err.println("ChannelFinder> could not find channel " + channelID + " to be updated.");
			throw new intt.itu.itut_q816.ChannelNotFound();
		}

		intt.itu.itut_q816.ChannelInfoType channelInfo = new ChannelInfoType(channelID,
																channelClass,
																eventTypes,
																excludedEventTypes,
																sourceClasses,
																excludedSourceClasses,
																channel);
		  synchronized(ChannelFinderProviderImpl.channels) {
		    ChannelFinderProviderImpl.channels.remove(channelID);
		  	ChannelFinderProviderImpl.channels.put(channelID, channelInfo);
		  }
		  get_context().push_channelChange_alarm(new ChannelChangeEventImpl(
							ChannelModificationType.ChannelUpdate,
							channelInfo)); 	
	}

    /**
     * Implementation of the ::itut_q816::ChannelFinderComponent::unregister operation.
     */
    public void
    unregister(String channelID)
    throws intt.itu.itut_q816.ChannelNotFound,
           intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE : Implement
        //

		intt.itu.itut_q816.ChannelInfoType channelInfo;
		if (ChannelFinderProviderImpl.channels.containsKey(channelID)) {

		  synchronized(ChannelFinderProviderImpl.channels) {
			
		  	channelInfo = (intt.itu.itut_q816.ChannelInfoType) 
		    ChannelFinderProviderImpl.channels.remove(channelID);
		  }
		}
		else
		  throw new intt.itu.itut_q816.ChannelNotFound();

		get_context().push_channelChange_alarm(new ChannelChangeEventImpl(
							ChannelModificationType.ChannelDelete,
							channelInfo)); 	
    }

}
