/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmsMibComponents.IpRoutingEntryProviderComposition;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.AttributeValueType;

import ist.coach.coachEmfCommon.Utils;

import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;

import ist.coach.coachEmsMib.IpRoutingEntryValueType;
import ist.coach.coachEmsCommon.SnmpIdentifiers;
import ist.coach.coachEmsCommon.IpRoutingEntryValueTypeImpl;

import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;

import org.opennms.protocols.snmp.SnmpSMI;
import ist.coach.coachEmfServices.EmfBasicLog.*;
import java.util.Hashtable;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmsMibComponents/IpRoutingEntryProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class IpRoutingEntryProviderImpl
     extends ist.coach.coachEmsMibComponents.IpRoutingEntryProviderComposition.IpRoutingEntryProvider_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
   org.omg.CORBA.ORB orb = null;
    private String _facade_name;

    protected static  Hashtable elements;
	private static int notifId = 14000;
	private BasicLog logSupport;

    ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;

	private static final String READ_COMMUNITY = SnmpIdentifiers.READ_COMMUNITY;
	private static final String WRITE_COMMUNITY = SnmpIdentifiers.WRITE_COMMUNITY;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public IpRoutingEntryProviderImpl()
    {
	    elements = new Hashtable();
    }
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		if ((connector = get_context().get_connection_connector()) == null)
            throw new org.omg.Components.InvalidConfiguration();
		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		orb = org.objectweb.ccm.CORBA.TheORB.getORB();

        System.err.println("IpRoutingEntryProvider configuration completed...");

    }
    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     */
    public String
    facade_name()
    {
        //
        // DONE : Implement
        //
        return _facade_name;
    }

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     */
    public void
    facade_name(String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
            _facade_name = new String(val);
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteDestGet operation.
     */
    public byte[]
    ipRouteDestGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		return data.routeDest.getBytes();
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteDestSet operation.
     */
    public void
    ipRouteDestSet(org.omg.CosNaming.NameComponent[] name, byte[] ipRouteDest)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteIfIndexGet operation.
     */
    public int
    ipRouteIfIndexGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteIfIndexOID = SnmpIdentifiers.IP_ROUTE_IFINDEX_OID + "." + data.routeDest;
		DataType ipRouteIfIndexData = null;

		try {
			ipRouteIfIndexData = connector.get(
				ipRouteIfIndexOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteIfIndex " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteIfIndexOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteIfIndex: " + e.reason);
			  throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteIfIndexData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteIfIndex " +
				"for IpRoutingEntry Object with name " + key + ":" +
				"\n Object with Snmp Object Identifier " + ipRouteIfIndexOID +
				" is not of expected type.");
			/***if (value.type().kind().value() == TCKind._tk_string) {
				System.err.println("ipRouteIfIndex = " +value.extract_string());
				return -1;
			}
			else
			******/
			throw new ApplicationError (error_code);

		}

		int ipRouteIfIndex = value.extract_long();
		return ipRouteIfIndex;

    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteIfIndexSet operation.
     */
    public void
    ipRouteIfIndexSet(org.omg.CosNaming.NameComponent[] name, int ipRouteIfIndex)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric1Get operation.
     */
    public int
    ipRouteMetric1Get(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteMetricOID = SnmpIdentifiers.IP_ROUTE_METRIC1_OID + "." + data.routeDest;
		DataType ipRouteMetricData = null;

		try {
			ipRouteMetricData = connector.get(
				ipRouteMetricOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteMetric1OID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteMetricOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteMetric1OID: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteMetricData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteMetric1OID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteMetricOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipRouteMetric = value.extract_long();
		return ipRouteMetric;

    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric1Set operation.
     */
    public void
    ipRouteMetric1Set(org.omg.CosNaming.NameComponent[] name, int ipRouteMetric1)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteMetricsPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric2Get operation.
     */
    public int
    ipRouteMetric2Get(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteMetricsPackageException
    {
       //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteMetricOID = SnmpIdentifiers.IP_ROUTE_METRIC2_OID + "." + data.routeDest;
		DataType ipRouteMetricData = null;

		try {
			ipRouteMetricData = connector.get(
				ipRouteMetricOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteMetric2OID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteMetricOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteMetric2OID: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteMetricData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteMetric2OID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteMetricOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipRouteMetric = value.extract_long();
		return ipRouteMetric;

    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric2Set operation.
     */
    public void
    ipRouteMetric2Set(org.omg.CosNaming.NameComponent[] name, int ipRouteMetric2)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteMetricsPackageException,

           ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric3Get operation.
     */
    public int
    ipRouteMetric3Get(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteMetricsPackageException
    {
       //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteMetricOID = SnmpIdentifiers.IP_ROUTE_METRIC3_OID + "." + data.routeDest;
		DataType ipRouteMetricData = null;

		try {
			ipRouteMetricData = connector.get(
				ipRouteMetricOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteMetric3OID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteMetricOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteMetric3OID: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteMetricData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteMetric3OID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteMetricOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipRouteMetric = value.extract_long();
		return ipRouteMetric;

    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric3Set operation.
     */
    public void
    ipRouteMetric3Set(org.omg.CosNaming.NameComponent[] name, int ipRouteMetric3)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteMetricsPackageException,

           ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric4Get operation.
     */
    public int
    ipRouteMetric4Get(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteMetricsPackageException
    {
       //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteMetricOID = SnmpIdentifiers.IP_ROUTE_METRIC4_OID + "." + data.routeDest;
		DataType ipRouteMetricData = null;

		try {
			ipRouteMetricData = connector.get(
				ipRouteMetricOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteMetric4OID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteMetricOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteMetric4OID: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteMetricData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteMetric4OID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteMetricOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipRouteMetric = value.extract_long();
		return ipRouteMetric;

    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric4Set operation.
     */
    public void
    ipRouteMetric4Set(org.omg.CosNaming.NameComponent[] name, int ipRouteMetric4)
    throws intt.itu.itut_x780.ApplicationError,
    ist.coach.coachEmsMib.NOipRouteMetricsPackageException,
    ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteNextHopGet operation.
     */
    public byte[]
    ipRouteNextHopGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteNHopOID = SnmpIdentifiers.IP_ROUTE_NHOP_OID + "." + data.routeDest;
		DataType ipRouteNHopData = null;

		try {
			ipRouteNHopData = connector.get(
				ipRouteNHopOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteNHopOID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteNHopOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteNHopOID: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteNHopData.value;


		if (value.type().kind().value() != TCKind._tk_string) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteNHopOID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteNHopOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		String ipRouteNHop = value.extract_string();
		return ipRouteNHop.getBytes();

    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::IpRouteNextHopSet operation.
     */
    public void
    IpRouteNextHopSet(org.omg.CosNaming.NameComponent[] name, byte[] ipRouteNextHop)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteTypeGet operation.
     */
    public int
    ipRouteTypeGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteTypeOID = SnmpIdentifiers.IP_ROUTE_TYPE_OID + "." + data.routeDest;
		DataType ipRouteTypeData = null;

		try {
			ipRouteTypeData = connector.get(
				ipRouteTypeOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteTypeOID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteTypeOID +
					" does not exist.");


			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteTypeOID: " + e.reason);


			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteTypeData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteTypeOID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteTypeOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipRouteType = value.extract_long();
		return ipRouteType;
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteTypeSet operation.
     */
    public void
    ipRouteTypeSet(org.omg.CosNaming.NameComponent[] name, int ipRouteType)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteProtoGet operation.
     */
    public int
    ipRouteProtoGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteProtoOID = SnmpIdentifiers.IP_ROUTE_PROTO_OID + "." + data.routeDest;
		DataType ipRouteProtoData = null;

		try {
			ipRouteProtoData = connector.get(
				ipRouteProtoOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteProtoOID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteProtoOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteProtoOID: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteProtoData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteProtoOID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteProtoOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipRouteProto = value.extract_long();
		return ipRouteProto;
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteProtoSet operation.
     */
    public void
    ipRouteProtoSet(org.omg.CosNaming.NameComponent[] name, int ipRouteProto)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {

    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteAgeGet operation.
     */
    public int
    ipRouteAgeGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,
    ist.coach.coachEmsMib.NOipRouteAgePackageException
    {
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteAgeOID = SnmpIdentifiers.IP_ROUTE_AGE_OID + "." + data.routeDest;
		DataType ipRouteAgeData = null;

		try {
			ipRouteAgeData = connector.get(
				ipRouteAgeOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteAgeOID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteAgeOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteAgeOID: " + e.reason);
			  throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteAgeData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteAgeOID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteAgeOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipRouteAge = value.extract_long();
		return ipRouteAge;
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMaskGet operation.
     */
    public byte[]
    ipRouteMaskGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteMaskOID = SnmpIdentifiers.IP_ROUTE_MASK_OID + "." + data.routeDest;
		DataType ipRouteMaskData = null;

		try {
			ipRouteMaskData = connector.get(
				ipRouteMaskOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteMaskOID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteMaskOID +
					" does not exist.");
		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteMaskOID: " + e.reason);
			  throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteMaskData.value;


		if (value.type().kind().value() != TCKind._tk_string) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteMaskOID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteMaskOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		String ipRouteMask = value.extract_string();
		return ipRouteMask.getBytes();

    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMaskSet operation.
     */
    public void
    ipRouteMaskSet(org.omg.CosNaming.NameComponent[] name, byte[] ipRouteMask)
    throws intt.itu.itut_x780.ApplicationError,
    ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric5Get operation.
     */
    public int
    ipRouteMetric5Get(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteMetricOID = SnmpIdentifiers.IP_ROUTE_METRIC5_OID + "." + data.routeDest;
		DataType ipRouteMetricData = null;

		try {
			ipRouteMetricData = connector.get(
				ipRouteMetricOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteMetric5OID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteMetricOID +
					" does not exist.");

		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteMetric5OID: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteMetricData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteMetric5OID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteMetricOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipRouteMetric = value.extract_long();
		return ipRouteMetric;

    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteMetric5Set operation.
     */
    public void
    ipRouteMetric5Set(org.omg.CosNaming.NameComponent[] name, int ipRouteMetric5)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipRouteMetricsPackageException,

           ist.coach.coachEmsMib.NOipRouteInfoSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpRoutingEntry_F::ipRouteInfoGet operation.
     */
    public String
    ipRouteInfoGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		String ipRouteInfoOID = SnmpIdentifiers.IP_ROUTE_INFO_OID + "." + data.routeDest;
		DataType ipRouteInfoData = null;

		try {
			ipRouteInfoData = connector.get(
				ipRouteInfoOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRouteInfoOID " +
					"for IpRoutingEntry Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipRouteInfoOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRouteInfoOID: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRouteInfoData.value;


		if (value.type().kind().value() != TCKind._tk_string) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpRoutingEntry> Could not retrieve ipRouteInfoOID " +
				"for IpRoutingEntry Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ipRouteInfoOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		String ipRouteInfo = value.extract_string();
		return ipRouteInfo;

    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     */
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
	   return Utils.string2name(_facade_name);
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     */
    public String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		return data.objectclass;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     */
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
      //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		int route_metric1, route_metric2, route_metric3, route_metric4, route_metric5;
		route_metric1 = route_metric2 = route_metric3 = route_metric4 = route_metric5 = -1;

		int route_age = -1;
		try {
		    route_metric1 = ipRouteMetric1Get(name);
		}
		catch(Exception e1) {
			System.err.println("IpRoutingEntryProvider> Exception calling ipRouteMetric1Get ");
		}

		try {
		    route_metric2 = ipRouteMetric2Get(name);
		}
		catch(Exception e2) {
			//System.err.println("IpRoutingEntryProvider> Exception calling ipRouteMetric2Get ");
		}

		try {
		    route_metric3 = ipRouteMetric3Get(name);
		}
		catch(Exception e3) {
			//System.err.println("IpRoutingEntryProvider> Exception calling ipRouteMetric3Get ");
		}

		try {
		    route_metric4 = ipRouteMetric4Get(name);
		}
		catch(Exception e4) {
			//System.err.println("IpRoutingEntryProvider> Exception calling ipRouteMetric4Get ");
		}

		try {
		    route_metric5 = ipRouteMetric5Get(name);
		}
		catch(Exception e5) {
			//System.err.println("IpRoutingEntryProvider> Exception calling ipRouteMetric5Get ");
		}

		try {
		    route_age = ipRouteAgeGet(name);
		}
		catch(Exception e5) {
			//System.err.println("IpRoutingEntryProvider> Exception calling ipRouteAgeGet ");
		}

		IpRoutingEntryValueTypeImpl ipRoutingEntryValueType =
			new IpRoutingEntryValueTypeImpl(
				ipRouteDestGet(name),
				ipRouteIfIndexGet(name),
				route_metric1,
				route_metric2,
				route_metric3,
				route_metric4,
				ipRouteNextHopGet(name),
				ipRouteTypeGet(name),
				ipRouteProtoGet(name),
				route_age,
				ipRouteMaskGet(name),
				route_metric5,
				ipRouteInfoGet(name),
				data.name,
				data.objectclass,
				data.packages,
				data.sourceIndicator,
				data.deletePolicy
			);
	/*****
	  System.err.println("IpRoutingEntryProvider> attributesGet: Ready to return " +
			  data.name + ", " + data.objectclass+ ", "+ data.sourceIndicator + ", "+
			  data.deletePolicy);
	*******/
		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "attributesGet finished successfully");
			return ipRoutingEntryValueType;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     */
    public String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
                //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

        return data.packages;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     */
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
	  String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

		return data.sourceIndicator;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     */
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
  		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpRoutingEntryStructure data =
			(IpRoutingEntryStructure) elements.get(key);

        return data.deletePolicy;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     */
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.DeleteError
    {
	    if (!elements.containsKey(Utils.name2string(name))) {

            ApplicationErrorInfoTypeImpl error_code =
            new ApplicationErrorInfoTypeImpl();

            error_code.error = new UIDType(
            intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
            intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

            error_code.details = new String ("object with name " +
            Utils.name2string(name) + " does not exist.");

            throw new ApplicationError(error_code);

	  }

	  IpRoutingEntryStructure ipRoutingEntry = null;
	  synchronized(elements) {
	    ipRoutingEntry =
	 		(IpRoutingEntryStructure) elements.remove(
				Utils.name2string(name));
		}
	org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
		0, (short) 0, (short) 0);
	get_context().push_objectDeletion(new ObjectDeletionImpl(eventTime, name,
						ipRoutingEntry.objectclass,
						getUniqueNotificationIdentifier(),
						ipRoutingEntry.sourceIndicator,
						new AttributeValueType[0]));
	Utils.pretty_log(logSupport,  Utils.name2string(name), 
			ipRoutingEntry.objectclass, //objectClassGet(name),
		  (short) LogSeverity._Info,
		  "successfully removed from management system");
    }

    protected static int getUniqueNotificationIdentifier() {

		notifId++;
        return notifId;
	}
}
