/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/

package ist.coach.coachEmsMibComponents.LogicalInterfaceProviderComposition;

import intt.itu.itut_x780.UIDType;

import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.AttributeValueChangeType;
import intt.itu.itut_x780.AttributeValueType;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.OperationalStateTypeHelper;
import intt.itu.itut_x780.OperationalStateType;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.StateChangedEventImpl;
import ist.coach.coachEmfCommon.StateChangedEventImpl;

import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;
import ist.coach.coachEmfServices.EmfBasicLog.*;

import ist.coach.coachEmsMib.LogicalInterfaceValueType;
import ist.coach.coachEmsMib.LogicalInterface_F;
import ist.coach.coachEmsMibComponents.LogicalInterfaceProviderHelper;
import ist.coach.coachEmsCommon.SnmpIdentifiers;

import ist.coach.coachEmsCommon.LogicalInterfaceValueTypeImpl;

import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;

import org.opennms.protocols.snmp.SnmpSMI;

import java.util.Hashtable;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmsMibComponents/LogicalInterfaceProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class LogicalInterfaceProviderImpl
     extends ist.coach.coachEmsMibComponents.LogicalInterfaceProviderComposition.LogicalInterfaceProvider_impl
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
   	org.omg.CORBA.ORB orb = null;
	private String _facade_name;
	private BasicLog logSupport;

	protected static Hashtable elements;
	private static int notifId = 11000;

	protected static final String IF_TABLE_OID = SnmpIdentifiers.IF_TABLE_OID;

	protected static final String IF_DESCR_OID              = SnmpIdentifiers.IF_DESCR_OID;
	protected static final String IF_TYPE_OID               = SnmpIdentifiers.IF_TYPE_OID;
	protected static final String IF_MTU_OID                = SnmpIdentifiers.IF_MTU_OID;
	protected static final String IF_SPEED_OID              = SnmpIdentifiers.IF_SPEED_OID;
	protected static final String IF_PHYSADDR_OID           = SnmpIdentifiers.IF_PHYSADDR_OID;
	protected static final String IF_ADMINSTATUS_OID        = SnmpIdentifiers.IF_ADMINSTATUS_OID;
	protected static final String IF_OPERSTATUS_OID         = SnmpIdentifiers.IF_OPERSTATUS_OID;
	protected static final String IF_LASTCHANGE_OID         = SnmpIdentifiers.IF_LASTCHANGE_OID;
	protected static final String IF_INOCTETS_OID           = SnmpIdentifiers.IF_INOCTETS_OID;
	protected static final String IF_INUCASTPKTS_OID        = SnmpIdentifiers.IF_INUCASTPKTS_OID;
	protected static final String IF_INNUCASTPKTS_OID       = SnmpIdentifiers.IF_INNUCASTPKTS_OID;
	protected static final String IF_INDISCARDS_OID         = SnmpIdentifiers.IF_INDISCARDS_OID;
	protected static final String IF_INERRORS_OID           = SnmpIdentifiers.IF_INERRORS_OID;
	protected static final String IF_INUNKNOWNPROTOS_OID    = SnmpIdentifiers.IF_INUNKNOWNPROTOS_OID;
	protected static final String IF_OUTOCTETS_OID          = SnmpIdentifiers.IF_OUTOCTETS_OID;
	protected static final String IF_OUTUCASTPKTS_OID       = SnmpIdentifiers.IF_OUTUCASTPKTS_OID;
	protected static final String IF_OUTNUCASTPKTS_OID      = SnmpIdentifiers.IF_OUTNUCASTPKTS_OID;
	protected static final String IF_OUTDISCARDS_OID        = SnmpIdentifiers.IF_OUTDISCARDS_OID;
	protected static final String IF_OUTERRORS_OID          = SnmpIdentifiers.IF_OUTERRORS_OID;
	protected static final String IF_OUTQLEN_OID            = SnmpIdentifiers.IF_OUTQLEN_OID;
	protected static final String IF_SPECIFIC_OID           = SnmpIdentifiers.IF_SPECIFIC_OID;

	protected static final String TIME_OID          = SnmpIdentifiers.TIME_OID;
	protected static final int COACH_LINK_UP        = 2;
	protected static final int COACH_LINK_DOWN      = 3;

	private static final String IF_LAST_CHANGE_PACKAGE      =
			  ist.coach.coachEmsMib.conditionalPackages.ifLastChangePackageType.value; //"ifLastChangePackage";
	private static final String IF_ADMIN_STATUS_PACKAGE     =
			 ist.coach.coachEmsMib.conditionalPackages.ifAdminStatusPackageType.value; // "ifAdminStatusPackage"
	private static final String OPERATIONAL_STATE_PACKAGE   =
			 ist.coach.coachEmsMib.conditionalPackages.ifOperationalStatusPackageType.value; //"operationalStatePackage"
	private static final String NON_UCAST_PACKAGE           =
		    ist.coach.coachEmsMib.conditionalPackages.ifNUcastPackageType.value; //"ifNUcastPackage"
	private static final String UNKNOWN_PROTOS_PACKAGE      =
		    ist.coach.coachEmsMib.conditionalPackages.ifUnknownProtosPackageType.value; //"ifUnknownProtosPackage"

	private static final String READ_COMMUNITY    = SnmpIdentifiers.READ_COMMUNITY;
	private static final String WRITE_COMMUNITY   = SnmpIdentifiers.WRITE_COMMUNITY;

	ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;
	ist.coach.coachEmfServices.SnmpAdapter.SnmpTrapDaemon config = null;

    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    LogicalInterfaceProviderImpl()
    {
        elements = new Hashtable();
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================


    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================

    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		if ((connector = get_context().get_connection_connector()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		if ((config = get_context().get_connection_config()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		orb = org.objectweb.ccm.CORBA.TheORB.getORB();
		System.err.println("LogicalInterface configuration completed...");


    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //

    public java.lang.String
    facade_name()
    {
        //
        //  DONE : implement
        //
        return _facade_name;
    }

    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     **/
    public void
    facade_name(java.lang.String val)
    {
        //
        //  DONE : implement
        //

		if (val != null)
			_facade_name = new String(val);
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifIndexGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifIndexGet operation.
     **/
    public int
    ifIndexGet(org.omg.CosNaming.NameComponent[] name)
    {
        //
        //  DONE : implement
        //

		//HACK: ApplicationError not declared to be thrown...

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
		/*	ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);*/

			return -1;
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		return data.getifIndex();
    }

    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifDescrGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifDescrGet operation.
     **/
    public java.lang.String
    ifDescrGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifDescrOid = new String(IF_DESCR_OID + "." + ifIndex);

		DataType ifDescrData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifDescrData = connector.get(
				ifDescrOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifDescr " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifDescrOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifDescr: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifDescrData.value;

		//if (value.type().kind().value() != TCKind._tk_string) {
		if (value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifDescr " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifDescrOid +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}
		//by digi
		//String ifDescr = value.extract_string();
		String ifDescr = new String(org.omg.CORBA.OctetSeqHelper.extract(value));
		return ifDescr;

    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifTypeGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifTypeGet operation.
     **/
    public int
    ifTypeGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifTypeOid = new String(IF_TYPE_OID + "." + ifIndex);

		DataType ifTypeData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifTypeData = connector.get(
				ifTypeOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifType " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifTypeOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifType: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifTypeData.value;

		if (value.type().kind().value() != TCKind._tk_long) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifType " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifTypeOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		int ifType = value.extract_long();

		return ifType;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifMtuGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifMtuGet operation.
     **/
    public int
    ifMtuGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifMtuOid = new String(IF_MTU_OID + "." + ifIndex);

		DataType ifMtuData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {

			ifMtuData = connector.get(
				ifMtuOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifMtu " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifMtuOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifMtu: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifMtuData.value;

		if (value.type().kind().value() != TCKind._tk_long) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifMtu " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifMtuOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		int ifMtu = value.extract_long();

		return ifMtu;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifSpeedGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifSpeedGet operation.
     **/
    public long
    ifSpeedGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifSpeedOid = new String(IF_SPEED_OID + "." + ifIndex);

		DataType ifSpeedData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifSpeedData = connector.get(
				ifSpeedOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifSpeed " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifSpeedOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifSpeed: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifSpeedData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifSpeed " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifSpeedOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifSpeed = value.extract_longlong();

		return ifSpeed;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifPhysAddressGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifPhysAddressGet operation.
     **/
    public byte[]
    ifPhysAddressGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifPhysAddrOid = new String(IF_PHYSADDR_OID + "." + ifIndex);

		DataType ifPhysAddrData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifPhysAddrData = connector.get(
				ifPhysAddrOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifPhysAddr " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifPhysAddrOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifPhysAddr: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifPhysAddrData.value;

		//if (value.type().kind().value() != TCKind._tk_string) {
		if (value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifPhysAddr " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifPhysAddrOid +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}
		//by digi
		//String ifPhysAddr = value.extract_string();
		//return ifPhysAddr.getBytes();

		byte [] ifPhysAddr = org.omg.CORBA.OctetSeqHelper.extract(value);
		return ifPhysAddr;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifAdminStatusGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifAdminStatusGet operation.
     **/
    public int
    ifAdminStatusGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifAdminStatusOid = new String(IF_ADMINSTATUS_OID + "." + ifIndex);

		DataType ifAdminStatusData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifAdminStatusData = connector.get(
				ifAdminStatusOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifAdminStatus " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifAdminStatusOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifAdminStatus: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifAdminStatusData.value;

		if (value.type().kind().value() != TCKind._tk_long) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifAdminStatus " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifAdminStatusOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		int ifAdminStatus = value.extract_long();

		return ifAdminStatus;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifAdminStatusSet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifAdminStatusSet operation.
     **/
    public void
    ifAdminStatusSet(org.omg.CosNaming.NameComponent[] name, int ifAdminStatus)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOifAdminStatusPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		if (!Utils.packageIsSupported(IF_ADMIN_STATUS_PACKAGE,
			packagesGet(name))) {
			throw new  ist.coach.coachEmsMib.NOifAdminStatusPackageException();
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();
		String ifAdminStatusOid = new String(IF_DESCR_OID + "." + ifIndex);

		org.omg.CORBA.Any value = orb.create_any();
		value.insert_long(ifAdminStatus);
		DataTypeImpl ifAdminStatusData = new DataTypeImpl(
			ifAdminStatusOid,
			value,
			SnmpSMI.SMI_INTEGER);

		//HACK: Snmp Port, Read community are hard coded...

		try {
			connector.set(
				ifAdminStatusData,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				WRITE_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not set ifAdminStatus " +
					"for LogicalInterface Object with name " + key + ".");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error setting ifAdminStatus: " + e.reason);
			throw new ApplicationError (error_code);
		}

    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifOperStatusGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifOperStatusGet operation.
     **/
    public int
    ifOperStatusGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifOperStatusOid = new String(IF_OPERSTATUS_OID + "." + ifIndex);

		DataType ifOperStatusData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifOperStatusData = connector.get(
				ifOperStatusOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifOperStatus " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifOperStatusOid +
					" does not exist.");
			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifOperStatus: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifOperStatusData.value;

		if (value.type().kind().value() != TCKind._tk_long) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifOperStatus " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifOperStatusOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		int ifOperStatus = value.extract_long();

		return ifOperStatus;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifLastChangeGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifLastChangeGet operation.
     **/
    public long
    ifLastChangeGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOifLastChangePackageException
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		if (!Utils.packageIsSupported(IF_LAST_CHANGE_PACKAGE,
				packagesGet(name))) {
			throw new ist.coach.coachEmsMib.NOifLastChangePackageException();
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifLastChangeOid = new String(IF_LASTCHANGE_OID + "." + ifIndex);

		DataType ifLastChangeData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifLastChangeData = connector.get(
				ifLastChangeOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifLastChange " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifLastChangeOid +
					" does not exist.");
			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifLastChange: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifLastChangeData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifLastChange " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifLastChangeOid +
				" is not of type string, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifLastChange = value.extract_longlong();

		return ifLastChange;
    }

    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifInOctetsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifInOctetsGet operation.
     **/
    public long
    ifInOctetsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifInOctetsOid = new String(IF_INOCTETS_OID + "." + ifIndex);

		DataType ifInOctetsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifInOctetsData = connector.get(
				ifInOctetsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifInOctets " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifInOctetsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifInOctets: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifInOctetsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifInOctets " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifInOctetsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifInOctets = value.extract_longlong();

		return ifInOctets;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifInUcastPktsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifInUcastPktsGet operation.
     **/
    public long
    ifInUcastPktsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifInUcastPktsOid = new String(IF_INUCASTPKTS_OID + "." + ifIndex);

		DataType ifInUcastPktsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifInUcastPktsData = connector.get(
				ifInUcastPktsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifInUcastPkts " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifInUcastPktsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifInUcastPkts: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifInUcastPktsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifInUcastPkts " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifInUcastPktsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifInUcastPkts = value.extract_longlong();

		return ifInUcastPkts;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifInNUcastPktsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifInNUcastPktsGet operation.
     **/
    public long
    ifInNUcastPktsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOnonUcastPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		if (!Utils.packageIsSupported(NON_UCAST_PACKAGE,
				packagesGet(name))) {
			throw new ist.coach.coachEmsMib.NOnonUcastPackageException();
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifInNUcastPktsOid = new String(IF_INNUCASTPKTS_OID + "." + ifIndex);

		DataType ifInNUcastPktsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifInNUcastPktsData = connector.get(
				ifInNUcastPktsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifInNUcastPkts " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifInNUcastPktsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifInNUcastPkts: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifInNUcastPktsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifInNUcastPkts " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifInNUcastPktsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifInNUcastPkts = value.extract_longlong();

		return ifInNUcastPkts;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifInDiscardsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifInDiscardsGet operation.
     **/
    public long
    ifInDiscardsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifInDiscardsOid = new String(IF_INDISCARDS_OID + "." + ifIndex);

		DataType ifInDiscardsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifInDiscardsData = connector.get(
				ifInDiscardsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifInDiscards " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifInDiscardsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifInDiscards: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifInDiscardsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifInDiscards " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifInDiscardsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifInDiscards = value.extract_longlong();

		return ifInDiscards;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifInErrorsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifInErrorsGet operation.
     **/
    public long
    ifInErrorsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifInErrorsOid = new String(IF_INERRORS_OID + "." + ifIndex);

		DataType ifInErrorsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifInErrorsData = connector.get(
				ifInErrorsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifInErrors " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifInErrorsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifInErrors: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifInErrorsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifInErrors " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifInErrorsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifInErrors = value.extract_longlong();

		return ifInErrors;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifInUnknownProtosGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifInUnknownProtosGet operation.
     **/
    public long
    ifInUnknownProtosGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOunknownProtosPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		if (!Utils.packageIsSupported(UNKNOWN_PROTOS_PACKAGE,
				packagesGet(name))) {
			throw new ist.coach.coachEmsMib.NOunknownProtosPackageException();
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifInUnknownProtosOid = new String(IF_INUNKNOWNPROTOS_OID + "." + ifIndex);

		DataType ifInUnknownProtosData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifInUnknownProtosData = connector.get(
				ifInUnknownProtosOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifInUnknownProtos " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifInUnknownProtosOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifInUnknownProtos: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifInUnknownProtosData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifInUnknownProtos " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifInUnknownProtosOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifInUnknownProtos = value.extract_longlong();

		return ifInUnknownProtos;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifOutOctetsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifOutOctetsGet operation.
     **/
    public long
    ifOutOctetsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifOutOctetsOid = new String(IF_OUTOCTETS_OID + "." + ifIndex);

		DataType ifOutOctetsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifOutOctetsData = connector.get(
				ifOutOctetsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifOutOctets " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifOutOctetsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifOutOctets: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifOutOctetsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifOutOctets " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifOutOctetsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifOutOctets = value.extract_longlong();

		return ifOutOctets;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifOutUcastPktsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifOutUcastPktsGet operation.
     **/
    public long
    ifOutUcastPktsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifOutUcastPktsOid = new String(IF_OUTUCASTPKTS_OID + "." + ifIndex);

		DataType ifOutUcastPktsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifOutUcastPktsData = connector.get(
				ifOutUcastPktsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifOutUcastPkts " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifOutUcastPktsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifOutUcastPkts: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifOutUcastPktsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifOutUcastPkts " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifOutUcastPktsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifOutUcastPkts = value.extract_longlong();

		return ifOutUcastPkts;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifOutNUcastPktsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifOutNUcastPktsGet operation.
     **/
    public long
    ifOutNUcastPktsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOnonUcastPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		if (!Utils.packageIsSupported(NON_UCAST_PACKAGE,
				packagesGet(name))) {
			throw new ist.coach.coachEmsMib.NOnonUcastPackageException();
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifOutNUcastPktsOid = new String(IF_OUTNUCASTPKTS_OID + "." + ifIndex);

		DataType ifOutNUcastPktsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifOutNUcastPktsData = connector.get(
				ifOutNUcastPktsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifOutNUcastPkts " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifOutNUcastPktsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifOutNUcastPkts: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifOutNUcastPktsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifOutNUcastPkts " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifOutNUcastPktsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifOutNUcastPkts = value.extract_longlong();

		return ifOutNUcastPkts;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifOutDiscardsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifOutDiscardsGet operation.
     **/
    public long
    ifOutDiscardsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifOutDiscardsOid = new String(IF_OUTDISCARDS_OID + "." + ifIndex);

		DataType ifOutDiscardsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifOutDiscardsData = connector.get(
				ifOutDiscardsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifOutDiscards " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifOutDiscardsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifOutDiscards: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifOutDiscardsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifOutDiscards " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifOutDiscardsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifOutDiscards = value.extract_longlong();

		return ifOutDiscards;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifOutErrorsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifOutErrorsGet operation.
     **/
    public long
    ifOutErrorsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifOutErrorsOid = new String(IF_OUTERRORS_OID + "." + ifIndex);

		DataType ifOutErrorsData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifOutErrorsData = connector.get(
				ifOutErrorsOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifOutErrors " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifOutErrorsOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifOutErrors: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifOutErrorsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifOutErrors " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifOutErrorsOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifOutErrors = value.extract_longlong();

		return ifOutErrors;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifOutQLenGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifOutQLenGet operation.
     **/
    public long
    ifOutQLenGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifOutQLenOid = new String(IF_OUTQLEN_OID + "." + ifIndex);

		DataType ifOutQLenData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifOutQLenData = connector.get(
				ifOutQLenOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifOutQLen " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifOutQLenOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifOutQLen: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifOutQLenData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifOutQLen " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifOutQLenOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		long ifOutQLen = value.extract_longlong();

		return ifOutQLen;
    }
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterface_F/ifSpecificGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterface_F::ifSpecificGet operation.
     **/
    public java.lang.String
    ifSpecificGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifSpecificOid = new String(IF_SPECIFIC_OID + "." + ifIndex);

		DataType ifSpecificData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifSpecificData = connector.get(
				ifSpecificOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ifSpecific " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifSpecificOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ifSpecific: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifSpecificData.value;

		if (value.type().kind().value() != TCKind._tk_string) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ifSpecific " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifSpecificOid +
				" is not of type string, as expected.");

			throw new ApplicationError (error_code);

		}

		String ifSpecific = value.extract_string();

		return ifSpecific;
    }
    //
    //  IDL:itu.intt/itut_m3120/TP_F/supportedByObjectListGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::TP_F::supportedByObjectListGet operation.
     **/
    public org.omg.CosNaming.NameComponent[][]
    supportedByObjectListGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		return new org.omg.CosNaming.NameComponent[0][0];

    }
    //
    //  IDL:itu.intt/itut_m3120/TP_F/operationalStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::TP_F::operationalStateGet operation.
     **/
    public intt.itu.itut_x780.OperationalStateType
    operationalStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOoperationalStatePackageException
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		if (!Utils.packageIsSupported(OPERATIONAL_STATE_PACKAGE,
				packagesGet(name))) {
			throw new  intt.itu.itut_m3120.NOoperationalStatePackageException();
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		int ifIndex = data.getifIndex();

		String ifOperStatusOid = new String(IF_OPERSTATUS_OID + "." + ifIndex);

		DataType ifOperStatusData = null;

		//HACK: Snmp Port, Read community are hard coded...

		try {
			ifOperStatusData = connector.get(
				ifOperStatusOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve Operational State " +
					"for LogicalInterface Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + ifOperStatusOid +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting Operational State: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifOperStatusData.value;

		if (value.type().kind().value() != TCKind._tk_long) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve Operational State " +
				"for LogicalInterface Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifOperStatusOid +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);

		}

		int ifOperStatusInt = value.extract_long();
		OperationalStateType operationalState = null;

		if (ifOperStatusInt == LogicalInterface_F.up ||
			ifOperStatusInt == LogicalInterface_F.testing)
			operationalState = OperationalStateType.enabled;
		else
			operationalState = OperationalStateType.disabled;

		return operationalState;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/nameGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
        //
        //  DONE : implement
        //
        return Utils.string2name(_facade_name);
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/objectClassGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     **/
    public java.lang.String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		return data.getObjectClass();
    }

    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/attributesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     **/
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		long ifLastChange = -1;
		OperationalStateType operationalState = OperationalStateType.enabled;
		long ifInNUcastPkts = -1;
		long ifOutNUcastPkts = -1;
		long ifInUnknownProtos = -1;

		try {
			ifInNUcastPkts = ifInNUcastPktsGet(name);
		}
		catch (ist.coach.coachEmsMib.NOnonUcastPackageException nonUcastPackage) {
		}

		try {
			ifOutNUcastPkts = ifOutNUcastPktsGet(name);
		}
		catch (ist.coach.coachEmsMib.NOnonUcastPackageException nonUcastPackage) {
		}

		try {
			ifInUnknownProtos = ifInUnknownProtosGet(name);
		}
		catch (ist.coach.coachEmsMib.NOunknownProtosPackageException unknownProtosPackage) {
		}

		try {
			ifLastChange = ifLastChangeGet(name);
		}
		catch (ist.coach.coachEmsMib.NOifLastChangePackageException noIfLastChange) {
			//System.err.println("ifLastChangePackage is not supported!");
			//System.err.println("Keeping value of " + ifLastChange + " for ifLastChange");
		}

		try {
			operationalState = operationalStateGet(name);
		}
		catch (intt.itu.itut_m3120.NOoperationalStatePackageException noOperationalState) {
		}

		LogicalInterfaceValueTypeImpl logicalInterfaceValueType =
			new LogicalInterfaceValueTypeImpl(

				supportedByObjectListGet(name),
				operationalState,

				data.getifIndex(),
				ifDescrGet(name),
				ifTypeGet(name),
				ifMtuGet(name),
				ifSpeedGet(name),
				ifPhysAddressGet(name),
				ifAdminStatusGet(name),
				ifLastChange,
				ifInOctetsGet(name),
				ifInUcastPktsGet(name),
				ifInNUcastPkts,
				ifInErrorsGet(name),
				ifInUnknownProtos,
				ifOutOctetsGet(name),
				ifOutUcastPktsGet(name),
				ifOutNUcastPkts,
				ifOutDiscardsGet(name),
				ifOutErrorsGet(name),
				ifOutQLenGet(name),
				ifSpecificGet(name),

				data.getName(),
				data.getObjectClass(),
				data.getPackages(),
				data.getSourceIndicator(),
				data.getDeletePolicy()
			);
	  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "attributesGet finished successfully");
		return logicalInterfaceValueType;

    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/packagesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     **/
    public java.lang.String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		return data.getPackages();
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/creationSourceGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     **/
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		return data.getSourceIndicator();
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/deletePolicyGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     **/
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) elements.get(key);

		return data.getDeletePolicy();
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/destroy:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     **/
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //

		if (!elements.containsKey(Utils.name2string(name))) {

            ApplicationErrorInfoTypeImpl error_code =
            new ApplicationErrorInfoTypeImpl();

            error_code.error = new UIDType(
            intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
            intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

            error_code.details = new String ("object with name " +
            Utils.name2string(name) + " does not exist.");

            throw new ApplicationError(error_code);

		}

		LogicalInterfaceDataStructure logicalInterfaceData = null;
		synchronized(elements) {
		  logicalInterfaceData =
			(LogicalInterfaceDataStructure) elements.remove(
					Utils.name2string(name));
		}
		try {
			config.unregister(name);
		}
		catch (ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_e) {
			System.err.println("There was a problem unregistering " + Utils.name2string(name) +
			"from the SNMP Trap Daemon");
			Utils.pretty_log(logSupport, Utils.name2string(name), 
				logicalInterfaceData.objectclass, //		objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error unregistering from the SNMP Trap Deamon: " + snmp_e.reason);
		}

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
				0, (short) 0, (short) 0);
		get_context().push_objectDeletion(new ObjectDeletionImpl(eventTime, name,
							logicalInterfaceData.objectclass,
							getUniqueNotificationIdentifier(),
							//logicalInterfaceData.getUniqueNotificationIdentifier(),
							logicalInterfaceData.sourceIndicator,
							new AttributeValueType[0]));
		Utils.pretty_log(logSupport,  Utils.name2string(name), 
				logicalInterfaceData.objectclass, //objectClassGet(name),
		  (short) LogSeverity._Info,
		  "successfully removed from management system");
    }
    // ==================================================================
    //
    // Public methods for the ::coachEmsMibComponents::CCM_LogicalInterfaceMgmt local interface.
    //
    // ==================================================================


	public static int getUniqueNotificationIdentifier() {

        notifId++;

        return (notifId);
   }


}
