/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Areski Flissi.
Contributor(s): 

====================================================================*/

package org.objectweb.ccm.filetransfer.cif;

/**
 * @author <a href="mailto:Areski.Flissi@lifl.fr">Areski Flissi</A>
 */

import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.lang.*;

public class FileTransfert_impl {

    
    
    private JButton label_ = null;
    private Image img = null;
    private JButton screen_ = null;
    private javax.swing.ImageIcon imgicon = null;
    

    //
    // The FileTransfert_impl object constructor to initialize the Receiver's GUI
    //

    FileTransfert_impl(JButton screen, JButton label) {

        
        screen_ = screen;
        label_ = label;        
        screen_.setBackground(Color.white);

    }

    //
    // A method to store received files for each channel
    //

    public void storeLastSend(byte[] last_send, String filename) {  

        FileOutputStream file = null;
        java.io.File currentdir = new java.io.File(System.getProperty("user.dir"));        
        currentdir = new java.io.File(currentdir.getParent());

        System.out.println("=== " + currentdir.getParent() + "/IMAGE/Receive/" + filename);

        try {
            file =
                new FileOutputStream(currentdir.getParent() + "/IMAGE/Receive/" + filename);
            file.write(last_send);
            file.close();

        } catch (java.io.IOException ex) {
            System.err.println("Can't write to " + ": " + ex.getMessage());
            System.exit(1);
        }
    }
    
    public synchronized void display_image(byte[] last_send, String filename) {
        
        // Display the received image         
        label_.setLabel("<<" + filename + ">>");
        imgicon = new javax.swing.ImageIcon(last_send);   
        screen_.setIcon(imgicon);    
    }

}
