/***************************************************************************/
/* COACH: Component Based Open Source Architecture for                     */
/*        Distributed Telecom Applications                                 */
/* See:   http://www.objectweb.org/                                        */
/*                                                                         */
/* Copyright (C) 2003 Lucent Technologies Nederland BV                     */
/*                    Bell Labs Advanced Technologies - EMEA               */
/*                                                                         */
/* Initial developer(s): Harold Batteram                                   */
/*                                                                         */
/* This library is free software; you can redistribute it and/or           */
/* modify it under the terms of the GNU Lesser General Public              */
/* License as published by the Free Software Foundation; either            */
/* version 2.1 of the License, or (at your option) any later version.      */
/*                                                                         */
/* This library is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        */
/* Lesser General Public License for more details.                         */
/*                                                                         */
/* You should have received a copy of the GNU Lesser General Public        */
/* License along with this library; if not, write to the Free Software     */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */
/***************************************************************************/
package org.coach.idltree;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;

public class IdlModel extends DefaultTreeModel {
    private TreePath selection;
    private IdlNode nodeRoot;

    public IdlModel() {
        super(new DefaultMutableTreeNode());
    }
    
    public IdlModel(IdlNode root) {
        super(root);
        nodeRoot = root;
        selection = new TreePath(root);
    }
    
    public TreePath getSelection() {
        return selection;
    }

    public void setSelection(TreePath s) {
        selection = s;
    }
    
    public void setRoot(IdlNode root) {
        super.setRoot(root);
        nodeRoot = root;
        selection = new TreePath(root);
    }        
}
