/*====================================================================

created on 20 mars 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.ccm.Containers.MetaInformation;

/**
 * @author hameau
 */
public class ComponentTypeImpl
extends InterfaceTypeImpl
implements ComponentType
{
    // internal propereties
    
	protected HomeType _home_type;
	protected String   _component_instance_factory_entrypt;

	// list of ports
	
    protected FacetPortTypeList      _facets_type;
    protected ReceptaclePortTypeList _receptacles_type;
    protected ConsumerPortTypeList   _consumers_type;
    protected EmitterPortTypeList    _emitters_type;
    protected PublisherPortTypeList  _publishers_ports;
 
    // related interfaces
    
    protected InterfaceTypeList _supported_interface;
    protected InterfaceType _equivalent_interface;

	// constructor
	
	public ComponentTypeImpl()
	{
		_home_type  	      = null;
		_facets_type  	      = new FacetPortTypeListImpl();
		_receptacles_type     = new ReceptaclePortTypeListImpl();
		_consumers_type       = new ConsumerPortTypeListImpl();
		_emitters_type        = new EmitterPortTypeListImpl();
		_publishers_ports     = new PublisherPortTypeListImpl();
        _supported_interface  = new InterfaceTypeListImpl();
        _equivalent_interface = null;
	}

	/* (non-Javadoc)
	 * @see org.objectweb.ccm.Containers.ComponentTypeOperations#home_type()
	 */
	public HomeType home_type() {		
		return _home_type;
	}

	public String component_instance_factory_entrypt() {
		
		return _component_instance_factory_entrypt;
	}

	
	
 


	/* (non-Javadoc)
	 * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#receptacles_type()
	 */
	public ReceptaclePortTypeList receptacles_type() {
		return _receptacles_type;
	}



	/* (non-Javadoc)
	 * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#consumers_type()
	 */
	public ConsumerPortTypeList consumers_type() {
		return _consumers_type;
	}

	

   /* (non-Javadoc)
    * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#facets_type()
    */
   public FacetPortTypeList facets_type() {
     return _facets_type;
   }


	/* (non-Javadoc)
	 * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#emitters_type()
	 */
	public EmitterPortTypeList emitters_type() {
		return _emitters_type;
	}

	/* (non-Javadoc)
	 * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#emitters_type(org.objectweb.ccm.Containers.MetaInformation.EmitterPortTypeList)
	 */
	public void emitters_type(EmitterPortTypeList value) {
		_emitters_type = value;
	}

	/* (non-Javadoc)
	 * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#publishers_ports()
	 */
	public PublisherPortTypeList publishers_ports() {
		return _publishers_ports;
	}

	
  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#facet_port_type_list()
   */
  public FacetPortTypeList facet_port_type_list()
  {
    return _facets_type;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#receptacle_port_type_list()
   */
  public ReceptaclePortTypeList receptacle_port_type_list()
  {
    return _receptacles_type;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#receptacle_port_type_list(org.objectweb.ccm.Containers.MetaInformation.ReceptaclePortTypeList)
   */


  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#consumer_port_type_list()
   */
  public ConsumerPortTypeList consumer_port_type_list()
  {
    return _consumers_type;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#emitter_port_type_list()
   */
  public EmitterPortTypeList emitter_port_type_list()
  {
     return _emitters_type;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#publisher_port_type_list()
   */
  public PublisherPortTypeList publisher_port_type_list()
  {
    return _publishers_ports;
  }

 
  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#supported_interfaces()
   */
  public InterfaceTypeList supported_interfaces()
  {
    return _supported_interface;
  }



  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#equivalent_interface()
   */
  public InterfaceType equivalent_interface()
  {
    return _equivalent_interface;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ComponentTypeOperations#equivalent_interface(org.objectweb.ccm.Containers.MetaInformation.InterfaceType)
   */
 

}
/*
  public void facet_port_type_list(FacetPortTypeList value)
  {
    _facets_type = value;    
  }

  public void publishers_ports(PublisherPortTypeList value) {
    _publishers_ports = value;
  }
    
  public void receptacle_port_type_list(ReceptaclePortTypeList value)
  {
    _receptacles_type = value;
  }
  
  public void consumer_port_type_list(ConsumerPortTypeList value)
  {
    _consumers_type = value;
  }
  
  public void emitter_port_type_list(EmitterPortTypeList value)
  {
    _emitters_type = value;
  }
 
   public void publisher_port_type_list(PublisherPortTypeList value)
  {
    _publishers_ports = value;    
  }

   public void equivalent_interface(InterfaceType value)
  {
    _equivalent_interface = value;   
  }

  public void consumers_type(ConsumerPortTypeList value) {
    _consumers_type = value;
  }
  
  public void receptacles_type(ReceptaclePortTypeList value) {
    _receptacles_type = value;
  }
 
  public void facets_type(FacetPortTypeList value) {
    _facets_type = value;
  }
  
  public void home_type(HomeType value) {
  
       _home_type = value; 
     }
     
     public void component_instance_factory_entrypt(String value) {
    
    _component_instance_factory_entrypt = value;
  }
  
*/