/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.binder;

import org.objectweb.ccm.descriptor.componentassembly.Providesport;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.util.CannotResolveReferenceException;
import org.omg.CORBA.Object;
import org.omg.Components.InvalidName;

/**
 * The providesport deployer is in charge to resolve an interface provided.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ProvidesportDeployer 
       extends ProvidesportDeployerContext 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * Return the provided interface describes by the providesport element.
     * @throws CannotResolveRefernceException is the component cannot be found
     * @throws InvalidName if the given port name is invalid
     * @return the provided interface.
     */
    public org.omg.CORBA.Object 
    getProvidedPort() 
    throws CannotResolveReferenceException, 
           InvalidName 
    {
        Providesport ppi = getProvidesport();
        Object o;
        if (getComponentinstantiationDeployer() != null) {
            o =
                getComponentinstantiationDeployer().getComponent().provide_facet(
                    ppi.getProvidesidentifier().getValue());
        } else {
            o =
                org
                    .omg
                    .Components
                    .CCMObjectHelper
                    .narrow(getFindbyDeployer().resolveReference())
                    .provide_facet(ppi.getProvidesidentifier().getValue());
        }    
        getLifeCycleManager().stepEndedSuccessFully();    
        return o;
    }
}
