/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.installer;

// Local Interface Import Statements
import org.objectweb.ccm.descriptor.componentassembly.beans.ComponentfilesBeanImpl;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.*;
/**
 * This handler is used to produce componentfilesdeployer from an
 * componentfiles bean .
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ComponentfilesDeployerHandler 
      extends HandlerBase 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private ComponentfilesDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================  
    /**
     * Produce the componentfile deployer binded
     * to the givean @param conp.
     * 
     * @param comp The componentfiles bean 
     * @return the deployer produced in initialize state
     * @throws InitializationError thrown if a problem is detected
     */ 
    public Object
    getInstance(ComponentfilesBeanImpl comp)
    throws InitializationError 
    {
        if(_deploy==null){
            _deploy=new ComponentfilesDeployer();
            applyCommonConfig(_deploy);
            _deploy.connectComponentfiles(comp);
            for(java.util.Iterator i=comp.getComponentfileList().iterator();i.hasNext(); ){
                ComponentfileDeployer current=(ComponentfileDeployer)
                                    getDeployer(i.next());                
                _deploy.connectComponentfileDeployer(current);
            }
            _deploy.initialize();
        }
       
        return (_deploy);
    }
    
}
