/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.installer;

import org.omg.Components.CCMHome;

/**
 * The existinfhomedeployer is in charge to found an existing home.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ExistinghomeDeployer 
       extends ExistinghomeDeployerContext 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * The resolve mehtod allow to invoke the home resolution.
     * @return The home founded
     * @throws ExistingHomeResolutionFailureException if the home cannot be founded
     */
    public CCMHome resolveHome()
    throws ExistingHomeResolutionFailureException
    {
        try{
            return  org.omg.Components.
                        CCMHomeHelper.narrow
                            (getFindbyDeployer().resolveReference());
        }
        catch(Exception e){
           throw new ExistingHomeResolutionFailureException(this,e); 
        }
    }
}
