/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.installer;


import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.*;
/**
 * Process the deployment of an Hostcollocation.
 *
 * @author <a href="mailto:frederic.briclet@lifl.fr">Briclet Frederic</a>
 *
 * @version 0.1
 */
public class HostcollocationDeployer 
    extends HostcollocationDeployerContext
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================


    /**
     * Deploy hostcollocation including all the children.
     * @throws FatalDeploymentException if a fatal problem occured 
     */
    public void 
    deploy()throws FatalDeploymentException
    {
        traverse(this,getHomeplacementDeployers());     
        getLifeCycleManager().stepEndedSuccessFully();        
    }
    /**
     * The homeplacementDeployer visitor to install a homeplacement.
     * 
     * @param home The homeplacementDeployer to execute
     * @param status The hostcollocation current status
     * @throws FatalDeploymentException
     */
    public void 
    visit(HomeplacementDeployer home,DeployerInactiveState status)
    throws FatalDeploymentException
    {
        home.deploy();
    }
    /**
     * Remove the hostcollocation including all the installed homes.
     * @throws FatalDeploymentException if a fatal problem occured    
     */
    public void 
    tearDown() 
    throws FatalDeploymentException
    
    {
        traverse(this,getHomeplacementDeployers());
        getLifeCycleManager().stepEndedSuccessFully();
    }
    /**
     * The homeplacementDeployer visitor to remove a homeplacement.
     * 
     * @param home The homeplacementDeployer to execute
     * @param status The hostcollocation current status
     * @throws FatalDeploymentException
     */
    public void 
    visit(HomeplacementDeployer home, DeployerActiveState status)
    throws FatalDeploymentException
    {
        home.tearDown();
    }
}
