/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.corba.generator.cif_idl.api;


// Package dependencies.
import org.objectweb.corba.ast.api.Scope;
import java.util.Vector;
import org.objectweb.corba.generator.common.lib.GenerationException;


/**
 * This is the interface for CIF interfaces generator.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</A>
 */

public interface CIF_IDLGenerator
         extends org.objectweb.corba.generator.common.api.GeneratorBase
{
    /**
     * Generate CIF interfaces from AST.
     * IR must be initialized first with method "initRepository()".
     *
     * @param scope - The scope to map.
     *
     * @return The list of mapped modules.
     **/
    public Vector
    declare_cif(Scope scope)
    throws GenerationException;


    /**
     * Remove CIF declarations from I.R.
     **/
    public void
    remove_decls();
}
