/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ________________________________________.

====================================================================*/

package org.objectweb.corba.generator.psdl.api;

import org.objectweb.corba.ast.api.AbstractStorageTypeDecl;
import org.objectweb.corba.generator.java.ast.api.InterfaceObject;
import org.objectweb.corba.generator.common.lib.GenerationException;


/**
 * This is the interface for PSDL key Mapping.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</A>
 */

public interface PSDLKeyMapping
{
    /**
     * Map a key definition into Java methods.
     *
     * @param generator - The PSDL to Java generator.
     * @param obj - The StorageHome mapping object.
     * @param ast - The abstract storage type defining this key.
     */
    public void
    toJava(org.objectweb.corba.generator.psdl.api.PSDL2JavaGenerator generator,
           InterfaceObject obj,
           AbstractStorageTypeDecl ast)
    throws GenerationException;
}
