/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.deployment.gui;

/**
 * This is a widget allowing to select component files from a list
 *
 * @author <a href="mailto:Christophe.Contreras@lifl.fr">Christophe Contreras</a>
 *
 */
public class AssemblyComponentFile
     extends org.objectweb.apollon.gui.bricks.AbstractBrick
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** the swing scroll list */
    private javax.swing.JComboBox scrolling_list;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     *  The default constructor.
     */
    public
    AssemblyComponentFile ()
    {
        this("idref");
    }
    
    /**
     * The constructor taking a label
     *
     * @param String label the label to use
     */
    public
    AssemblyComponentFile (String label)
    {
        super(label);
        
        // inits the scroll list
        scrolling_list = new javax.swing.JComboBox(
            (String[])
                CCMIdRefsSingleton.getInstance()
                    .getComponentFilesList()
                    .toArray(new String[0])
            );

        scrolling_list.setEditable(true);

        this.add(this.scrolling_list);
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * The getter method
     */
    public String
    get()
    {
        return (String)this.scrolling_list.getSelectedItem();
    }

    /**
     * The setter method
     */
    public void
    set (String line_text)
    {
        this.scrolling_list.setSelectedItem(line_text);
    }

}
