/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.api;

/** The console's imports */
import org.objectweb.util.browser.naming.api.Decoder;

/**
 * Parses an XML file containing the browser configuration.<br>
 * XML element example : <br>
 * <i>
 * &lt;context&gt;<br>
 * &nbsp;&nbsp;&lt;decoders&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;decoder java-class="org.objectweb.openccm.tools.adminGUI.plugins.CorbaIORDecoder" /&gt;<br>
 * &nbsp;&nbsp;&lt;/decoders&gt;<br>
 * &lt;/context&gt;
 * </i>
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public interface ContextProperty {

    /**
     * Returns the decoder chain created from the given XML file.
     * @return The decoder chain to use when adding object
     */
    public Decoder getDecoder();

}
