/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s):

====================================================================*/

package org.objectweb.ccm.descriptor.corbacomponent.gui;

import org.objectweb.ccm.descriptor.corbacomponent.beans.*;
import org.objectweb.ccm.descriptor.corbacomponent.*;

/**
 * This is an extension to the Apollon generated framework around corbacomponent DTD
 *  it looks for subelements that could contain files to archive
 *  and calls their own zipper extensions to do the same job
 *  any found file name is sent to a zip factory
 *
 */
public class FileinarchiveZipper
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     *  The zip method called from parents
     *
     */
    public void
    zipCall(
        FileinarchiveBean fileinarchive
        , org.objectweb.openccm.deployment.gui.ZipFactory zip_factory
        )
    {
        // testing the sub element 'link'
        LinkBean link
         = (LinkBean)
            fileinarchive.getLink();

        // only adds the file to zip if link is unset
        if (link == null)
        {
            // adds the existing file to the factory
            zip_factory
                .addFileToZip(
                    fileinarchive.getName()
                    );
        }
    }
}
