@echo off
REM # ====================================================================
REM #
REM # OpenCCM: The Open CORBA Component Model Platform
REM # Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
REM # Contact: openccm@objectweb.org
REM #
REM # This library is free software; you can redistribute it and/or
REM # modify it under the terms of the GNU Lesser General Public
REM # License as published by the Free Software Foundation; either
REM # version 2.1 of the License, or any later version.
REM #
REM # This library is distributed in the hope that it will be useful,
REM # but WITHOUT ANY WARRANTY; without even the implied warranty of
REM # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
REM # Lesser General Public License for more details.
REM #
REM # You should have received a copy of the GNU Lesser General Public
REM # License along with this library; if not, write to the Free Software
REM # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
REM # USA
REM #
REM # Initial developer(s): Areski Flissi
REM # Contributor(s): 
REM #
REM # ====================================================================
REM #
REM #  Starting the Ant Compilation Process.
REM #  Installing OpenCCM on the device connected via ActiveSync
REM #
REM # ====================================================================

set rcmd=externals\rcmd\rcmd.exe
set build_dir=%cd%\build

call ant %1 -buildfile build.xml

if "%1"=="clean" goto build_clean

:build
echo *************************************
echo * Installing OpenCCM on the WinCE PDA
echo *************************************


echo  ==^> Copying [%build_dir%] directory to connected device...
echo * Copying OpenCCM command scripts...
call %rcmd% /nologo /nologo2 copy %build_dir%\bin\*.bat \OpenCCM\build\bin\ /i
echo * Copying OpenCCM Launcher XML configuration file...
call %rcmd% /nologo /nologo2 copy %build_dir%\xml\launcher\*.xml \OpenCCM\build\xml\launcher\ /i
echo * Copying OpenCCM default DeployerConfig .dcf file...
call %rcmd% /nologo /nologo2 copy %build_dir%\xml\deployer_config\*.dcf \OpenCCM\build\xml\deployer_config\ /i
echo * Copying OpenCCM NodeProperties.npd file...
call %rcmd% /nologo /nologo2 copy %build_dir%\xml\descriptor\dci\*.npd \OpenCCM\build\xml\descriptor\dci\ /i
echo * Copying OpenCCM Java libraries...
call %rcmd% /nologo /nologo2 copy %build_dir%\jar\*.jar \OpenCCM\build\jar\ /i
call %rcmd% /nologo /nologo2 copy %build_dir%\lib\*.jar \OpenCCM\build\lib\ /i
echo * Copying OpenCCM externals...
call %rcmd% /nologo /nologo2 copy %build_dir%\externals\jidlscript\*.jar \OpenCCM\build\externals\jidlscript\ /i
call %rcmd% /nologo /nologo2 copy %build_dir%\externals\xerces\*.jar \OpenCCM\build\externals\xerces\ /i
call %rcmd% /nologo /nologo2 copy %build_dir%\externals\apollon\*.jar \OpenCCM\build\externals\apollon\ /i
echo * Copying OpenCCM DTD files
call %rcmd% /nologo /nologo2 copy %build_dir%\dtd\ccm\*.dtd \OpenCCM\build\dtd\ccm\ /i
echo * Copying OpenCCM archive demos
 call %rcmd% /nologo /nologo2 copy %build_dir%\archives\*.aar \OpenCCM\build\archives\ /i
echo * done.

goto:eof


:build_clean

echo  ==^> Deleting previous OpenCCM build dir on the device...

echo * removing \OpenCCM\build\bin\*.bat...
call %rcmd% /nologo del \OpenCCM\build\bin\*.bat

echo * removing \OpenCCM\build\xml\launcher\*.xml...
call %rcmd% /nologo /nologo2 del \OpenCCM\build\xml\launcher\*.xml

echo * removing \OpenCCM\build\xml\deployer_config\*.dcf...
call %rcmd% /nologo /nologo2 del \OpenCCM\build\xml\deployer_config\*.dcf

echo * removing \OpenCCM\build\jar\*.jar...
call %rcmd% /nologo /nologo2 del \OpenCCM\build\jar\*.jar

echo * removing \OpenCCM\build\lib\*.jar...
call %rcmd% /nologo /nologo2 del \OpenCCM\build\lib\*.jar

echo * removing \OpenCCM\build\externals\*...
call %rcmd% /nologo /nologo2 del \OpenCCM\build\externals\jidlscript\*.*
call %rcmd% /nologo /nologo2 del \OpenCCM\build\externals\xerces\*.*
call %rcmd% /nologo /nologo2 del \OpenCCM\build\externals\apollon\*.*

echo * removing \OpenCCM\build\dtd\ccm\*.dtd...
call %rcmd% /nologo /nologo2 del \OpenCCM\build\dtd\ccm\*.dtd
call %rcmd% /nologo /nologo2 del \OpenCCM\build\xml\descriptor\dci\*.npd

echo * removing \OpenCCM\build\archives\*.aar...
call %rcmd% /nologo /nologo2 del \OpenCCM\build\archives\*.aar

echo done.