#!/bin/sh -f
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Christophe Demarey.
# Contributor(s): ______________________________________.
#
# ====================================================================

# Goes to the production module root dir
cd ..

# Install the OpenCCM platform
ccm_install

# Starts the Interface Repository
ir3_start

# Checks an idl3 file
idl3_check test/sample.idl3

# Feeds an idl3 file
ir3_feed test/sample.idl3

# Tests the ir3_idl2 command
ir3_idl2 sample

# Tests the ir3_idl3 command
ir3_idl3 sample

# Tests the ir3_idl2 command
ir3_idl2 sample

# Tests the psdl command
psdl test/sample.psdl

# Tests the cidl command
cidl test/sample.cidl

# Tests the ir3_destroy command
ir3_destroy sample

# Stops the Interface Repository
ir3_stop

# Starts the Interface Repository with all IDL files
ir3_start_with_all

# Deinstall the OpenCCM platform
ccm_deinstall

