/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: XMI2IR.java,v 1.1 2004/04/15 09:09:01 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.api;

/**
 * Interface of the xmi2ir command.
 *
 * @author <a href="mailto:Pierre.Carpentier@lifl.fr">Pierre Carpentier</a>
 *
 * @version 1.1
 */

public interface XMI2IR
         extends org.objectweb.openccm.command.api.Compiler
{

    /**
     * Inits the UML repository.
     *
     * @return TRUE if the UML repository is initialized.
     */
    public boolean
    initUMLRepository();


    /**
     * Parses the UML XMI file for reading the UML Package.
     *
     * @param filename The filename of the UML XMI file.
     *
     * @throw org.xml.sax.SAXException If any parse errors occur.
     * @throw javax.xml.parsers.ParserConfigurationException If a DocumentBuilder cannot be
     *        created which satisfies the configuration requested.
     * @throw java.io.IOException If any IO errors occur.
     */
    public void
    parseXMIFile(String filename)
    throws
        org.xml.sax.SAXException,
        javax.xml.parsers.ParserConfigurationException,
        java.io.IOException;

}
