/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: TheUMLPackage.java,v 1.1 2004/04/15 09:09:01 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.lib;

/**
 * This class encapsulates the UML package singleton object.
 *
 * @author <a href="mailto:Pierre.Carpentier@lifl.fr">Pierre Carpentier</a>
 *
 * @version 1.0
 */

public class TheUMLPackage {

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** To store the UML package singleton object. */
    private static org.omg.uml.UMLPackage uml_package_ = null;


    // ==================================================================
    //
    // No constructor.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Obtain the UML package singleton object.
     *
     * @return The UML package singleton object.
     */
    public static org.omg.uml.UMLPackage
    getUMLPackage()
    {
        return uml_package_;
    }


    /**
     * Set the UML package singleton object.
     *
     * @param uml_package The UML package singleton object.
     */
    public static void
    setUMLPackage(org.omg.uml.UMLPackage uml_package)
    {
        uml_package_ = uml_package;
    }


}
