/*====================================================================

 ObjectWeb Util Launcher Package.
 Copyright (C) 2004 INRIA & USTL - LIFL - GOAL
 Contact: architecture@objectweb.org

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA

 Initial developer(s): Romain Rouvoy.
 Contributor(s): .

 --------------------------------------------------------------------
 $Id: HelloWorld.java,v 1.1 2004/02/05 20:29:57 rouvoy Exp $
 ====================================================================*/

import org.objectweb.util.launcher.StringList;
import org.objectweb.util.trace.TraceSystem;

/**
 * Simple example for presenting a launcher use case.
 * 
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 * @version 0.1
 */
public class HelloWorld {
    
    /**
     * Print the list of arguments.
     * @param args the arguments to print.
     */
    private static void printArguments(String[] args) {
        StringBuffer arg = new StringBuffer();
        arg.append("-> Arguments [");
        for (int i = 0 ; i < args.length ; i++)
            arg.append(args[i] + ", ");
        arg.append("]");
        TraceSystem.get("HelloWorld").debug(arg.toString());
    }

    /**
     * Print the Java Properties.
     *
     */
    private static void printJavaProperties() {
        java.util.Iterator iter = System.getProperties().entrySet().iterator();
        StringBuffer ppty = new StringBuffer();
        ppty.append("-> Properties [");
        while (iter.hasNext()) {
          java.util.Map.Entry entry = (java.util.Map.Entry) iter.next() ;
          ppty.append("("+entry.getKey()+"="+entry.getValue()+"), ");
        } 
        ppty.append("]");
        TraceSystem.get("HelloWorld").debug(ppty.toString());
    }

    /**
     * Main method.
     * @param args the arguments.
     */
    public static void main(String[] args)
    {
        TraceSystem.get("HelloWorld").debug("-> Thread [" + Thread.currentThread() + "]");
        TraceSystem.get("HelloWorld").debug("-> ClassLoader [" + Thread.currentThread().getContextClassLoader() + "]");
        printArguments(args);
        printJavaProperties();
        for (int i = 0 ; i < 5 ; i++)
            TraceSystem.get("HelloWorld").info("-> Message n"+i+": Hello World "+(new StringList(args))+"!");
    }
}
