/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmfServicesComponents;
/**
 **  Implementation skeleton class for the ::coachEmfServicesComponents::AlarmChannelProvider component.
 **/
public class AlarmChannelProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_AlarmChannelProvider,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    private CCM_AlarmChannelProvider_Context the_context_;
	public static final String OBJECT_TYPE = "AlarmChannelProvider";
		/* business logic */
	String _channelId;
	String[] _sourceClasses = null;
	String[] _excludedSourceClasses = null;
	String[] _eventTypes = null;
	String[] _excludedEventTypes = null;
	intt.itu.itut_q816.ChannelFinderComponent channel_finder = null;
    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    AlarmChannelProviderMonolithicImpl()
    {
        the_context_ = null;
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_AlarmChannelProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		System.err.println("AlarmChannelProvider configuration started...");
		channel_finder = the_context_.get_connection_channelfinder_admin();

		if (channel_finder == null || _channelId == null) {
			System.err.println("AlarmChannelProvider failed to locate ChannelFinder!");
			throw new org.omg.Components.InvalidConfiguration();
		}

		if (_sourceClasses == null || _sourceClasses.length == 0) {
			System.err.println("Alarm Channel sourceClasses are not set..Proceeding manually");
			_sourceClasses = new String[1];
			_sourceClasses[0] = "IpNode";
		}

		if (_eventTypes == null || _eventTypes.length == 0) {
			System.err.println("Alarm Channel eventTypes are not set..Proceeding manually");
			_eventTypes = new String[6];
			_eventTypes[0] = "ObjectCreation";
			_eventTypes[1] = "ObjectDeletion";
			_eventTypes[2] = "StateChangedEvent";
			_eventTypes[3] = "Heartbeat";
			_eventTypes[4] = "ChannelChangeEvent";
			_eventTypes[5] = "OperationalViolation";
		}

			_excludedEventTypes = new String[0];
			_excludedSourceClasses =  new String[0];

		try {

			org.omg.CORBA.Object myself =
				((org.omg.Components.SessionContext) the_context_).get_CCM_object();
			if (myself == null)
			System.err.println("AlarmChannelProvider there is a problem getting myself as a component!");

			channel_finder.register(_channelId,
									OBJECT_TYPE,
									_eventTypes,
									_excludedEventTypes,
									_sourceClasses,
									_excludedSourceClasses,
									myself);

		}
		catch(intt.itu.itut_x780.ApplicationError ex) {
			System.err.println("Application Error exception caught while registering " +
				"AlarmChannelProvider " + _channelId + " to ChannelFinder");
		}
		catch(intt.itu.itut_q816.ChannelAlreadyRegistered channel_ex) {
			System.err.println("ChannelAlreadyRegistered  exception caught while registering " +
                "AlarmChannelProvider " + _channelId + " to ChannelFinder");
		}
		catch(org.omg.Components.IllegalState state_ex) {
			System.err.println("org.omg.Components.IllegalState  exception caught while registering " +
                "AlarmChannelProvider " + _channelId + " to ChannelFinder");
		}
		System.err.println(_channelId + " AlarmChannelProvider configuration completed...");


    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_AlarmChannelProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // DONE: implement !!!
        //
		try {
			channel_finder.unregister(_channelId);
		}
		catch(intt.itu.itut_q816.ChannelNotFound channel_ex) {
			System.err.println("ChannelNotFound exception caught unregistering " +
				_channelId + " from ChannelFinderService ");

		}
		catch(intt.itu.itut_x780.ApplicationError ex) {
			System.err.println("ApplicationError exception caught unregistering " +
				_channelId + " from ChannelFinderService ");
		}
    }
    // ==================================================================
    //
    // Public methods for the CCM_AlarmChannelProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider/push_f_objectCreation_alarm:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider::push_f_objectCreation_alarm operation.
     **/
    public void
    push_f_objectCreation_alarm(ist.coach.itut_q816Components.ObjectCreation event)
    {
        //
        //  DONE : implement
        //
		the_context_.push_objectCreation_alarm(event);
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider/push_f_objectDeletion_alarm:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider::push_f_objectDeletion_alarm operation.
     **/
    public void
    push_f_objectDeletion_alarm(ist.coach.itut_q816Components.ObjectDeletion event)
    {
        //
        //  DONE : implement
        //
		the_context_.push_objectDeletion_alarm(event);
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider/push_f_operational_alarm:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider::push_f_operational_alarm operation.
     **/
    public void
    push_f_operational_alarm(ist.coach.itut_q816Components.OperationalViolation event)
    {
        //
        //  DONE : implement
        //
		the_context_.push_operational_alarm(event);
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider/push_f_stateChanged_alarm:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider::push_f_stateChanged_alarm operation.
     **/
    public void
    push_f_stateChanged_alarm(ist.coach.itut_q816Components.StateChangedEvent event)
    {
        //
        //  DONE : implement
        //
		the_context_.push_stateChanged_alarm(event);
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider/push_h_heartbeat:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider::push_h_heartbeat operation.
     **/
    public void
    push_h_heartbeat(ist.coach.itut_q816Components.Heartbeat event)
    {
        //
        //  DONE : implement
        //
		event.channelID = new String(_channelId);
		//System.err.println("AlarmChannelProvider>push_h_heartbeat> Attempting to forward heartbeat to client...");
		the_context_.push_heartbeat_event(event);
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider/push_cf_channelChange_event:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider::push_cf_channelChange_event operation.
     **/
    public void
    push_cf_channelChange_event(ist.coach.itut_q816Components.ChannelChangeEvent event)
    {
        //
        //  DONE : implement
        //
		the_context_.push_channelChange_event(event);
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider/push_l_attributeValueChange_alarm:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider::push_l_attributeValueChange_alarm operation.
     **/
    public void
    push_l_attributeValueChange_alarm(ist.coach.coachEmfServicesComponents.LogAttributeValueChange event)
    {
        //
        //  DONE : implement
        //
		the_context_.push_log_attributeValueChange_alarm(event);
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider/push_l_threshold_alarm:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider::push_l_threshold_alarm operation.
     **/
    public void
    push_l_threshold_alarm(ist.coach.coachEmfServicesComponents.LogThresholdAlarm event)
    {
        //
        //  DONE : implement
        //
		the_context_.push_log_threshold_alarm(event);
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider_Executor/channelId:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::channelId attribute as accessor operation.
     **/
    public java.lang.String
    channelId()
    {
        //
        //  DONE : implement
        //
        return _channelId;
    }

    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::channelId attribute as mutator operation.
     **/
    public void
    channelId(java.lang.String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
			_channelId = new String(val);
		else
			_channelId = new String();
		System.err.println("Channel Id is set to " + _channelId);
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider_Executor/sourceClasses:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::sourceClasses attribute as accessor operation.
     **/
    public java.lang.String[]
    sourceClasses()
    {
        //
        //  DONE : implement
        //
        return _sourceClasses;
    }

    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::sourceClasses attribute as mutator operation.
     **/
    public void
    sourceClasses(java.lang.String[] val)
    {
        //
        //  DONE : implement
        //
		System.err.print("AlarmChannelProvider will serve:");
		if (val == null)
			_sourceClasses = new String[0];
		else
			_sourceClasses = val;
		for (int i = 0; i < _sourceClasses.length; i++)
			System.err.print(_sourceClasses[i] + ", ");
		System.err.println();
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider_Executor/excludedSourceClasses:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::excludedSourceClasses attribute as accessor operation.
     **/
    public java.lang.String[]
    excludedSourceClasses()
    {
        //
        //  DONE : implement
        //
        return _excludedSourceClasses;
    }

    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::excludedSourceClasses attribute as mutator operation.
     **/
    public void
    excludedSourceClasses(java.lang.String[] val)
    {
        //
        //  DONE : implement
        //
		System.err.println("excludedSourceClasses will be set...");
		if (val == null)
			_excludedSourceClasses = new String[0];
		else
			_excludedSourceClasses = val;
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider_Executor/eventTypes:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::eventTypes attribute as accessor operation.
     **/
    public java.lang.String[]
    eventTypes()
    {
        //
        //  DONE : implement
        //
        return _eventTypes;
    }

    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::eventTypes attribute as mutator operation.
     **/
    public void
    eventTypes(java.lang.String[] val)
    {
        //
        //  DONE : implement
        //

		if (val == null)
			_eventTypes = new String[0];
		else
			_eventTypes = val;

		System.err.println(channelId() + " " + _eventTypes.length + " eventTypes supported..");
    }
    //
    //  IDL:coach.ist/coachEmfServicesComponents/CCM_AlarmChannelProvider_Executor/excludedeventTypes:1.0
    //
    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::excludedeventTypes attribute as accessor operation.
     **/
    public java.lang.String[]
    excludedeventTypes()
    {
        //
        //  DONE : implement
        //
        return _excludedEventTypes;
    }

    /**
     **  Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::excludedeventTypes attribute as mutator operation.
     **/
    public void
    excludedeventTypes(java.lang.String[] val)
    {
        //
        //  DONE : implement
        //
		if (val == null)
			_excludedEventTypes = new String[0];
		else
			_excludedEventTypes = val;
    }
}
