/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmsMibComponents;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.AttributeValueType;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ObjectCreationImpl;
import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;

import ist.coach.coachEmsMib.IpProtocolMonitorValueType;
import ist.coach.coachEmsMib.IpProtocolMonitor_F;
import ist.coach.coachEmsMibComponents.IpProtocolMonitorProviderHelper;

import ist.coach.coachEmsCommon.IpProtocolMonitorValueTypeImpl;
import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;

import org.opennms.protocols.snmp.SnmpSMI;

import java.util.Hashtable;

/**
 **  Implementation skeleton class for the ::coachEmsMibComponents::IpProtocolMonitorProvider component.
 **  Business operations MUST be completed !!!
 **/
public class IpProtocolMonitorProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_IpProtocolMonitorProvider,
                  ist.coach.coachEmsMibComponents.CCM_IpProtocolMonitorMgmt,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    private CCM_IpProtocolMonitorProvider_Context the_context_;

    org.omg.CORBA.ORB orb = null;
    private String _facade_name;

    private Hashtable elements;
	private int notifId = 1200;

    ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;

	public static final String IP_FWD_TYPE_OID			= ".1.3.6.1.2.1.4.1.0";
	public static final String IP_DEFAULT_TTL_OID		= ".1.3.6.1.2.1.4.2.0";
	public static final String IP_INRECEIVE_OID		= ".1.3.6.1.2.1.4.3.0";
	public static final String IP_INHDRERRORS_OID		= ".1.3.6.1.2.1.4.4.0";
	public static final String IP_INADDRERRORRS_OID	= ".1.3.6.1.2.1.4.5.0";
	public static final String IP_FWDDATAGRAMS_OID		= ".1.3.6.1.2.1.4.6.0";
	public static final String IP_INUNKNOWNPROTO_OID	= ".1.3.6.1.2.1.4.7.0";
	public static final String IP_INDISCARDS_OID		= ".1.3.6.1.2.1.4.8.0";
	public static final String IP_INDELIVERS_OID		= ".1.3.6.1.2.1.4.9.0";
	public static final String IP_OUTREQUESTS_OID		= ".1.3.6.1.2.1.4.10.0";
	public static final String IP_OUTDISCARDS_OID		= ".1.3.6.1.2.1.4.11.0";
	public static final String IP_NOROUTE_OID			= ".1.3.6.1.2.1.4.12.0";
	public static final String IP_REASMTIMEOUT_OID		= ".1.3.6.1.2.1.4.13.0";
	public static final String IP_REASMREQ_OID			= ".1.3.6.1.2.1.4.14.0";
	public static final String IP_REASMOK_OID			= ".1.3.6.1.2.1.4.15.0";
	public static final String IP_REASMFAIL_OID		= ".1.3.6.1.2.1.4.16.0";
	public static final String IP_FRAGOK_OID			= ".1.3.6.1.2.1.4.17.0";
	public static final String IP_FRAGFAIL_OID			= ".1.3.6.1.2.1.4.18.0";
	public static final String IP_FRAGCREATE_OID		= ".1.3.6.1.2.1.4.19.0";
	public static final String IP_ROUTING_DISCARDS_OID	= ".1.3.6.1.2.1.4.23.0";

	private static final String IP_PROTOCOL_CONFIG_PACKAGE = "ipProtocolConfigurationSetPackage";

	private static final String READ_COMMUNITY = "public";
	private static final String WRITE_COMMUNITY = "private";

    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    IpProtocolMonitorProviderMonolithicImpl()
    {
        the_context_ = null;

		this.elements = new Hashtable();
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_IpProtocolMonitorProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		if ((connector = the_context_.get_connection_connector()) == null)
            throw new org.omg.Components.InvalidConfiguration();
		orb = org.objectweb.ccm.CORBA.TheORB.getORB();

        System.err.println("IpProtocolMonitorProvider configuration completed...");

    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_IpProtocolMonitorProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_IpProtocolMonitorProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmsMibComponents/CCM_IpProtocolMonitorProvider/get_mgmt:1.0
    //
    /**
     **  Implementation of the ::coachEmsMibComponents::CCM_IpProtocolMonitorProvider::get_mgmt operation.
     **/
    public ist.coach.coachEmsMibComponents.CCM_IpProtocolMonitorMgmt
    get_mgmt()
    {
        return this;
    }
    //
    //  IDL:coach.ist/itut_x780Components/CCM_NamedComponent_Executor/facade_name:1.0
    //

    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     **/
    public void
    facade_name(java.lang.String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
            _facade_name = new String(val);

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipForwardingGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipForwardingGet operation.
     **/
    public int
    ipForwardingGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipForwaringData = null;

		try {
			ipForwaringData = this.connector.get(
				IP_FWD_TYPE_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipForwaring " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_FWD_TYPE_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipForwaringData.value;

		if (value.type().kind().value() != TCKind._tk_long) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipForwaring " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_FWD_TYPE_OID +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);
		}

		int ipForwarding = value.extract_long();

		return ipForwarding;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipForwardingSet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipForwardingSet operation.
     **/
    public void
    ipForwardingSet(org.omg.CosNaming.NameComponent[] name, int ipForwarding)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOipProtocolConfigurationSetPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		if (!Utils.packageIsSupported(IP_PROTOCOL_CONFIG_PACKAGE, packagesGet(name))) {
			System.err.println("Package " + IP_PROTOCOL_CONFIG_PACKAGE + " is not supported " +
				"by IpProtocolMonitor Object " + key);

			throw new ist.coach.coachEmsMib.NOipProtocolConfigurationSetPackageException();
		}

		org.omg.CORBA.Any value = orb.create_any();

		value.insert_long(ipForwarding);
		DataTypeImpl ipForwardingData = new DataTypeImpl(
			IP_FWDDATAGRAMS_OID,
			value,
			SnmpSMI.SMI_INTEGER);

		try {
			this.connector.set(
				ipForwardingData,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				WRITE_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("Could not set ipForwarding " +
				"for IpProtocolMonitor Object with name " + key + ".");

			throw new ApplicationError(error_code);

		}


    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipDefaultTTLGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipDefaultTTLGet operation.
     **/
    public int
    ipDefaultTTLGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpProtocolMonitorDataStructure data =
		(IpProtocolMonitorDataStructure) this.elements.get(key);

	DataType ipDefaultTTLData = null;

	try {
		ipDefaultTTLData = this.connector.get(
			IP_DEFAULT_TTL_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipDefaultTTL " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_DEFAULT_TTL_OID +
				" does not exist.");
		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipDefaultTTLData.value;

	if (value.type().kind().value() != TCKind._tk_long) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipDefaultTTL " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + IP_DEFAULT_TTL_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	}

	int ipDefaultTTL = value.extract_long();

	return ipDefaultTTL;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipDefaultTTLSet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipDefaultTTLSet operation.
     **/
    public void
    ipDefaultTTLSet(org.omg.CosNaming.NameComponent[] name, int ipDefaultTTL)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOipProtocolConfigurationSetPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		if (!Utils.packageIsSupported(IP_PROTOCOL_CONFIG_PACKAGE, packagesGet(name))) {
			System.err.println("Package " + IP_PROTOCOL_CONFIG_PACKAGE + " is not supported " +
				"by IpProtocolMonitor Object " + key);

			throw new ist.coach.coachEmsMib.NOipProtocolConfigurationSetPackageException();
		}

		org.omg.CORBA.Any value = orb.create_any();

		value.insert_long(ipDefaultTTL);
		DataTypeImpl ipDefaultTTLData = new DataTypeImpl(
			IP_DEFAULT_TTL_OID,
			value,
			SnmpSMI.SMI_INTEGER);

		try {
			this.connector.set(
				ipDefaultTTLData,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				WRITE_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("Could not set ipDefaultTTL " +
				"for IpProtocolMonitor Object with name " + key + ".");

			throw new ApplicationError(error_code);

		}

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInReceivesGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInReceivesGet operation.
     **/
    public long
    ipInReceivesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpProtocolMonitorDataStructure data =
		(IpProtocolMonitorDataStructure) this.elements.get(key);

	DataType ipInReceivesData = null;

	try {
		ipInReceivesData = this.connector.get(
			IP_INRECEIVE_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipInReceivesData " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_INRECEIVE_OID +
				" does not exist.");
		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipInReceivesData.value;

	if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipInReceivesData " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + IP_INRECEIVE_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	}

	long ipInReceives = value.extract_longlong();

	return ipInReceives;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInHdrErrorsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInHdrErrorsGet operation.
     **/
    public long
    ipInHdrErrorsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpProtocolMonitorDataStructure data =
		(IpProtocolMonitorDataStructure) this.elements.get(key);

	DataType ipInHeaderErrorsData = null;

	try {
		ipInHeaderErrorsData = this.connector.get(
			IP_INHDRERRORS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipInErrorHeaders " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_INHDRERRORS_OID +
				" does not exist.");
		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipInHeaderErrorsData.value;

	if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipInHeaderErrors " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + IP_INHDRERRORS_OID +
			" is not of type long, as expected.");

		throw new ApplicationError (error_code);
	}

	long ipInHeaderErrors = value.extract_longlong();

	return ipInHeaderErrors;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInAddrErrorsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInAddrErrorsGet operation.
     **/
    public long
    ipInAddrErrorsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DOPE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpProtocolMonitorDataStructure data =
		(IpProtocolMonitorDataStructure) this.elements.get(key);

	DataType ipInAddrErrorsData = null;

	try {
		ipInAddrErrorsData = this.connector.get(
			IP_INADDRERRORRS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipInAddrErrors " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_INADDRERRORRS_OID +
				" does not exist.");
		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipInAddrErrorsData.value;

	if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipInAddrErrors " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + IP_INADDRERRORRS_OID +
			" is not of type long, as expected.");

		throw new ApplicationError (error_code);
	}

	long ipInAddrErrors = value.extract_longlong();

	return ipInAddrErrors;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipForwDatagramsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipForwDatagramsGet operation.
     **/
    public long
    ipForwDatagramsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipForwardedDatagramsData = null;

		try {
			ipForwardedDatagramsData = this.connector.get(
				IP_FWDDATAGRAMS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipForwardedDatagrams " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_FWDDATAGRAMS_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipForwardedDatagramsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipForwardedDatagrams " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_FWDDATAGRAMS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipForwardedDatagrams = value.extract_longlong();

		return ipForwardedDatagrams;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInUnknownProtosGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInUnknownProtosGet operation.
     **/
    public long
    ipInUnknownProtosGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipInUnknownProtosData = null;

		try {
			ipInUnknownProtosData = this.connector.get(
				IP_INUNKNOWNPROTO_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipInUnknownProtos " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_INUNKNOWNPROTO_OID +
				" does not exist.");
		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipInUnknownProtosData.value;

	if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipInUnknownProtos " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + IP_INUNKNOWNPROTO_OID +
			" is not of type long, as expected.");

		throw new ApplicationError (error_code);
	}

	long ipInUnknownProtos = value.extract_longlong();

	return ipInUnknownProtos;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInDiscardsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInDiscardsGet operation.
     **/
    public long
    ipInDiscardsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipInDiscardsData = null;

		try {
			ipInDiscardsData = this.connector.get(
				IP_INDISCARDS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipInDiscards " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_INDISCARDS_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipInDiscardsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipInDiscards " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_INDISCARDS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipInDiscards = value.extract_longlong();

		return ipInDiscards;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInDeliversGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInDeliversGet operation.
     **/
    public long
    ipInDeliversGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipInDeliversData = null;

		try {
			ipInDeliversData = this.connector.get(
				IP_INDELIVERS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipInDelivers " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_INDELIVERS_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipInDeliversData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipInDelivers " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_INDELIVERS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipInDelivers = value.extract_longlong();

		return ipInDelivers;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipOutRequestsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipOutRequestsGet operation.
     **/
    public long
    ipOutRequestsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipOutRequestsData = null;

		try {
			ipOutRequestsData = this.connector.get(
				IP_OUTREQUESTS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipOutRequests " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_OUTREQUESTS_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipOutRequestsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipOutRequests " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_OUTREQUESTS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipOutRequests = value.extract_longlong();

		return ipOutRequests;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipOutDiscardsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipOutDiscardsGet operation.
     **/
    public long
    ipOutDiscardsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipOutDiscardsData = null;

		try {
			ipOutDiscardsData = this.connector.get(
				IP_OUTDISCARDS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipOutDiscards " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_OUTDISCARDS_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipOutDiscardsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipOutDiscards " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_ROUTING_DISCARDS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipOutDiscards = value.extract_longlong();

		return ipOutDiscards;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipOutNoRoutesGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipOutNoRoutesGet operation.
     **/
    public long
    ipOutNoRoutesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipNoRoutesData = null;

		try {
			ipNoRoutesData = this.connector.get(
				IP_NOROUTE_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipNoRoutes " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_NOROUTE_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipNoRoutesData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipNoRoutes " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_NOROUTE_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipNoRoutes = value.extract_longlong();

		return ipNoRoutes;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipReasmTimeoutGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipReasmTimeoutGet operation.
     **/
    public int
    ipReasmTimeoutGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipReasmTimeoutData = null;

		try {
			ipReasmTimeoutData = this.connector.get(
				IP_REASMTIMEOUT_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipReasmTimeouts " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_REASMTIMEOUT_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipReasmTimeoutData.value;

		if (value.type().kind().value() != TCKind._tk_long) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipReasmTimeouts " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_REASMTIMEOUT_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		int ipReasmTimeouts = value.extract_long();

		return ipReasmTimeouts;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipReasmReqdsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipReasmReqdsGet operation.
     **/
    public long
    ipReasmReqdsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipReasmReqsData = null;

		try {
			ipReasmReqsData = this.connector.get(
				IP_REASMREQ_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipReasmReqs " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_REASMREQ_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipReasmReqsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipReasmReqs " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_REASMREQ_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipReasmReqs = value.extract_longlong();

		return ipReasmReqs;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipReasmOKsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipReasmOKsGet operation.
     **/
    public long
    ipReasmOKsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipReasmOKsData = null;

		try {
			ipReasmOKsData = this.connector.get(
				IP_REASMOK_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipReasmOKs " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_REASMOK_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipReasmOKsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipReasmOKs " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_REASMOK_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipReasmOKs = value.extract_longlong();

		return ipReasmOKs;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipReasmFailsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipReasmFailsGet operation.
     **/
    public long
    ipReasmFailsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipReasmFailsData = null;

		try {
			ipReasmFailsData = this.connector.get(
				IP_REASMFAIL_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipReasmFails " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_REASMFAIL_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipReasmFailsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipReasmFails " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_REASMFAIL_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipReasmFails = value.extract_longlong();

		return ipReasmFails;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipFragOKsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipFragOKsGet operation.
     **/
    public long
    ipFragOKsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipFragOKsData = null;

		try {
			ipFragOKsData = this.connector.get(
				IP_FRAGOK_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipFragOKs " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_FRAGOK_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipFragOKsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipFragOKs " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_FRAGOK_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipFragOKs = value.extract_longlong();

		return ipFragOKs;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipFragFailsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipFragFailsGet operation.
     **/
    public long
    ipFragFailsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipFragFailsData = null;

		try {
			ipFragFailsData = this.connector.get(
				IP_FRAGFAIL_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipFragFails " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_FRAGFAIL_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipFragFailsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipFragFails " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_FRAGFAIL_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipFragFails = value.extract_longlong();

		return ipFragFails;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipFragCreatesGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipFragCreatesGet operation.
     **/
    public long
    ipFragCreatesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipFragCreatesData = null;

		try {
			ipFragCreatesData = this.connector.get(
				IP_FRAGCREATE_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipFragCreates " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_FRAGCREATE_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipFragCreatesData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipFragCreates " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_FRAGCREATE_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipFragCreates = value.extract_longlong();

		return ipFragCreates;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipRoutingDiscardsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipRoutingDiscardsGet operation.
     **/
    public long
    ipRoutingDiscardsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		DataType ipRoutingDiscardsData = null;

		try {
			ipRoutingDiscardsData = this.connector.get(
				IP_ROUTING_DISCARDS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRoutingDiscards " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + IP_ROUTING_DISCARDS_OID +
					" does not exist.");
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRoutingDiscardsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipRoutingDiscards " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + IP_ROUTING_DISCARDS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipRoutingDiscards = value.extract_longlong();

		return ipRoutingDiscards;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/nameGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
        //
        //  DONE : implement
        //
        return Utils.string2name(_facade_name);
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/objectClassGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     **/
    public java.lang.String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		return data.objectclass;

    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/attributesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     **/
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		IpProtocolMonitorValueTypeImpl ipProtocolMonitorValueType =
			new IpProtocolMonitorValueTypeImpl(
				ipForwardingGet(name),
				ipDefaultTTLGet(name),
				ipInReceivesGet(name),
				ipInHdrErrorsGet(name),
				ipInAddrErrorsGet(name),
				ipForwDatagramsGet(name),
				ipInUnknownProtosGet(name),
				ipInDiscardsGet(name),
				ipInDeliversGet(name),
				ipOutRequestsGet(name),
				ipOutDiscardsGet(name),
				ipOutNoRoutesGet(name),
				ipReasmTimeoutGet(name),
				ipReasmReqdsGet(name),
				ipReasmOKsGet(name),
				ipReasmFailsGet(name),
				ipFragOKsGet(name),
				ipFragFailsGet(name),
				ipFragCreatesGet(name),
				ipRoutingDiscardsGet(name),

				data.name,
				data.objectclass,
				data.packages,
				data.sourceIndicator,
				data.deletePolicy
			);

			return ipProtocolMonitorValueType;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/packagesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     **/
    public java.lang.String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

        return data.packages;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/creationSourceGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     **/
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

		return data.sourceIndicator;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/deletePolicyGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     **/
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) this.elements.get(key);

        return data.deletePolicy;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/destroy:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     **/
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //

	if (!this.elements.containsKey(Utils.name2string(name))) {

            ApplicationErrorInfoTypeImpl error_code =
            new ApplicationErrorInfoTypeImpl();

            error_code.error = new UIDType(
            intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
            intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

            error_code.details = new String ("object with name " +
            Utils.name2string(name) + " does not exist.");

            throw new ApplicationError(error_code);

	}

	IpProtocolMonitorDataStructure ipProtocolMonitorData =
		(IpProtocolMonitorDataStructure) this.elements.remove(
			Utils.name2string(name));

	org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
		0, (short) 0, (short) 0);
	the_context_.push_objectDeletion(new ObjectDeletionImpl(eventTime, name,
						ipProtocolMonitorData.objectclass,
						getUniqueNotificationIdentifier(),
//						ipProtocolMonitorData.getUniqueNotificationIdentifier(),
						ipProtocolMonitorData.sourceIndicator,
						new AttributeValueType[0]));

    }
    // ==================================================================
    //
    // Public methods for the ::coachEmsMibComponents::CCM_IpProtocolMonitorMgmt local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmsMibComponents/IpProtocolMonitorMgmt/create:1.0
    //
    /**
     **  Implementation of the ::coachEmsMibComponents::IpProtocolMonitorMgmt::create operation.
     **/
    public void
    create(org.omg.CosNaming.NameComponent[] name,
			java.lang.String objectClass,
			java.lang.String[] packages,
			short deletePolicy,
			intt.itu.itut_x780.SourceIndicatorType sourceIndicator,
			org.omg.CosNaming.NameComponent[] superior,
			byte[] mgmtIpAddress,
			int snmpPort,
			int supportedSnmpVersions)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError
    {
        //
        //  DONE : implement
        //

        if (this.elements.containsKey(Utils.name2string(name))) {

            CreateErrorInfoTypeImpl errorCode =
                new CreateErrorInfoTypeImpl();

            errorCode.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

            errorCode.details = new String(Utils.name2string(name) +
             " object already exists.");
            throw new intt.itu.itut_x780.CreateError(errorCode);
        }

		IpProtocolMonitorDataStructure ipProtocolData =
			new IpProtocolMonitorDataStructure(
			 name,
                objectClass,
                packages,
                sourceIndicator,
                deletePolicy,
                new String(mgmtIpAddress),
                snmpPort,
                supportedSnmpVersions);

		this.elements.put(Utils.name2string(name), ipProtocolData);

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT (System.currentTimeMillis(),
                    0, (short) 0, (short) 0);
        the_context_.push_objectCreation(new ObjectCreationImpl(eventTime,
                                                name,
                                                objectClass,
												getUniqueNotificationIdentifier(),
												//ipProtocolData.getUniqueNotificationIdentifier(),
                                                sourceIndicator,
                                                new AttributeValueType[0]));

    }
    //
    //  IDL:coach.ist/coachEmsMibComponents/IpProtocolMonitorMgmt/facade_name:1.0
    //
    /**
     **  Implementation of the ::coachEmsMibComponents::IpProtocolMonitorMgmt::facade_name operation.
     **/
    public java.lang.String
    facade_name()
    {
        //
        //  DONE : implement
        //
        return _facade_name;
    }

    public int getUniqueNotificationIdentifier() {

		notifId++;
        return notifId;
	}

	class IpProtocolMonitorDataStructure {

		public NameComponent [] name;
        public String objectclass;
        public String [] packages;
        public SourceIndicatorType sourceIndicator;
        public short deletePolicy;

		private int notificationIdentifier;
        private String mgmtIpAddress;
        private int snmpPort;
        private int supportedSnmpVersions;


		public IpProtocolMonitorDataStructure() {}

		public IpProtocolMonitorDataStructure(
			NameComponent [] name,
            String objectclass,
            String [] packages,
            SourceIndicatorType sourceIndicator,
            short deletePolicy,
			String mgmtIpAddress,
            int snmpPort,
            int supportedSnmpVersions) {

			this.name = name;
            this.objectclass = objectclass;
            this.packages = packages;
            this.sourceIndicator = sourceIndicator;
            this.deletePolicy = deletePolicy;
			this.notificationIdentifier = 0;
            this.mgmtIpAddress = mgmtIpAddress;
            this.snmpPort = snmpPort;
            this.supportedSnmpVersions = supportedSnmpVersions;
        }

        public int getUniqueNotificationIdentifier() {

            this.notificationIdentifier++;

            return (this.notificationIdentifier);
        }

        public String getMgmtIpAddress() {
            return mgmtIpAddress;
        }

        public int getSnmpPort() {
            return snmpPort;
        }

        public int getSupportedSnmpVersions() {
            return supportedSnmpVersions;
        }
	}
}
